DEFINT A-Z
'=================================declarations
DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE FUNCTION choose$ (list$)
DECLARE SUB draw.grid ()
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION takevalue% (text$)
DECLARE FUNCTION select.picture% ()
DECLARE FUNCTION check.buttons ()
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE SUB load.icons ()
DECLARE SUB load (file.chosen$)
DECLARE SUB assign.picture.names ()
DECLARE SUB save ()
DECLARE SUB drawscreen ()
DECLARE SUB showmouse ()
'=================================interrupts
ON ERROR GOTO errhandle

'=================================variables
CONST pi = 3.141592654#
CONST xtextsize = 8
CONST ytextsize = 16

TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE
DIM SHARED gridsize, xgridrange, ygridrange, xgridmax, ygridmax
SCREEN 12: CLS
PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0
DO
    gridsize = takevalue("What size should the grid units be?")
LOOP UNTIL gridsize > 2 AND gridsize < 31
xgridrange = 320 / gridsize
ygridrange = 280 / gridsize
xgridmax = xgridrange * gridsize
ygridmax = ygridrange * gridsize

DIM SHARED trapdoor(70), elevator(70), gravity(70), antigrav(70)
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(10000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED rusure(5000), colour, map(xgridrange, ygridrange), picture(2633), numpics
DIM SHARED xmax, xmin, ymax, ymin, drawmode, button(2633)
drawmode = 1
'=========================Misc.
'------------set up screen
GET (0, 0)-(1, 1), picture
drawscreen
colour = 15
'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
showmouse
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)
xmax = 0: ymax = 0
xmin = 1000: ymin = 1000
'===============================main program==================================
DO
    SELECT CASE buttonpressed
        CASE 1
            a = mousex
            B = mousey
            IF a < xgridmax AND B < ygridmax THEN
                mapx = INT(a / gridsize)
                mapy = INT(B / gridsize)
                IF mapx > xmax THEN xmax = mapx
                IF mapx < xmin THEN xmin = mapx
                IF mapy > ymax THEN ymax = mapy
                IF mapy < ymin THEN ymin = mapy
                showmouse
                IF drawmode = 1 THEN
                    LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), colour, BF
                    LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), , B
                    PSET (10 + mapx, 300 + mapy), colour
                    map(mapx, mapy) = colour
                ELSEIF drawmode = 2 THEN
                    IF doneonce THEN
                        corner2x = mapx
                        corner2y = mapy
                    ELSE
                        doneonce = 1
                        corner1x = mapx
                        corner1y = mapy
                    END IF
                END IF
                showmouse
            ELSEIF a >= 500 THEN
                colour = INT(B / ytextsize)
            ELSE
                SELECT CASE check.buttons
                    CASE 1
                        SHELL "dir/b/one *.pic > junk"
                        'file.chosen$ = taketext$("Which one?")
                        file.chosen$ = choose$("junk")
                        IF file.chosen$ <> "" THEN
                            load (file.chosen$)
                        ELSE
                            showmouse
                            drawscreen
                            showmouse
                        END IF
                    CASE 2
                        save
                    CASE 3
                        f = FREEFILE
                        OPEN "junk" FOR OUTPUT AS #f
                        PRINT #f, "yes.pic"
                        PRINT #f, "no.pic"
                        CLOSE #f
                        IF choice("junk", 2, "Are you sure?") = 1 THEN
                            showmouse
                            REDIM SHARED map(xgridrange, ygridrange)
                            drawscreen
                            showmouse
                            xmax = 0: ymax = 0
                            xmin = 1000: ymin = 1000
                        END IF
                    CASE 4
                        f = FREEFILE
                        OPEN "junk" FOR OUTPUT AS #f
                        PRINT #f, "yes.pic"
                        PRINT #f, "no.pic"
                        CLOSE #f
                        IF choice("junk", 2, "Are you sure you want to exit?") = 1 THEN done = 1
                    CASE 5
                        RUN
                    CASE 6
                        drawmode = 1
                    CASE 7
                        drawmode = 2
                END SELECT
            END IF
        CASE 2
            a = mousex
            B = mousey
            IF a < xgridmax AND B < ygridmax THEN
                mapx = INT(a / gridsize)
                mapy = INT(B / gridsize)
                map(mapx, mapy) = 0
                showmouse
                LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), 0, BF
                LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), , B
                PSET (10 + mapx, 300 + mapy), 0
                showmouse
            END IF
        CASE 0
            IF doneonce THEN
                doneonce = 0
                showmouse
                LINE (10 + corner1x, 300 + corner1y)-(10 + corner2x, 300 + corner2y), colour, BF
                IF corner2x < corner1x THEN corner1x = corner1x + 1
                IF corner2y < corner1y THEN corner1y = corner1y + 1
                IF corner2x > corner1x THEN corner2x = corner2x + 1
                IF corner2y > corner1y THEN corner2y = corner2y + 1
               
                IF corner2x = corner1x THEN corner2x = corner1x + SGN(mousex - corner1x)
                IF corner2y = corner1y THEN corner2y = corner1y + SGN(mousey - corner1y)
               
                IF corner2x = corner1x THEN corner2x = corner2x + 1
                IF corner2y = corner1y THEN corner2y = corner2y + 1
                
                LINE (corner1x * gridsize, corner1y * gridsize)-(corner2x * gridsize, corner2y * gridsize), colour, BF
                draw.grid
                showmouse
            END IF
    END SELECT
LOOP UNTIL done
'CHAIN "icomenu9.bas"
END
'===============================subroutines===================================
errhandle:
    PLAY "l40mbo2dgb"
    RESUME NEXT

FUNCTION buttonpressed%
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

FUNCTION check.buttons
    x = mousex: y = mousey
    IF x >= 44 * xtextsize - 2 AND x < 58 * xtextsize THEN
        IF y < 7 * ytextsize THEN
            FOR cy = 1 TO 7
                IF y < cy * ytextsize THEN EXIT FOR
            NEXT cy
        END IF
    END IF
    check.buttons = cy
END FUNCTION

FUNCTION choice (filename$, icons, text$)
    '==================================set values, draw window
    DIM file$(icons), buttonxsize(icons), buttonysize(icons)
    DIM buttonx(icons), buttony(icons)
    '----- load the icon data
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    n = 0
    DEF SEG = VARSEG(button(0))
    FOR n = 1 TO icons
        INPUT #f, file$(n)
        BLOAD file$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
    NEXT n
    CLOSE #f

    '---- determine the necessary size of the window
    '--x
    tlen = LEN(text$)
    textx = 40 - INT(tlen / 2)
    FOR n = 1 TO icons
        xminsize = xminsize + buttonxsize(n) + 10
    NEXT n
    IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize
 
    '--y
    FOR n = 1 TO icons
        IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
    NEXT n
    yminsize = yminsize + 40

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE texty, textx: PRINT text$;

    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon positions

    '-- x
    a = xminsize
    FOR n = 1 TO icons
        a = a - buttonxsize(n)
    NEXT n
    a = a / (icons + 1)
    icx = 320 - (xminsize / 2)
    FOR n = 1 TO icons
        icx = icx + a
        buttonx(n) = icx
        icx = icx + buttonxsize(n)
    NEXT n

    '-- y
    a = y2 - (y1 + 2 * ytextsize)
    a = y2 - a / 2
    FOR n = 1 TO icons
        buttony(n) = a - buttonysize(n) / 2
    NEXT n
                         
    '----- load and draw the icons
    FOR n = 1 TO icons
        DEF SEG = VARSEG(button(0))
        BLOAD file$(n), VARPTR(button(0))
        PUT (buttonx(n), buttony(n)), button
    NEXT n
    DEF SEG

    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            FOR n = 1 TO icons
                IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
                    IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
                        choice = n
                        gotone = n
                    END IF
                END IF
            NEXT n
        END IF
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
END FUNCTION

FUNCTION choose$ (list$)
    l = FREEFILE

    '---------- check for listsize
    OPEN list$ FOR INPUT AS #l
    DO
        LINE INPUT #l, junk$
        numopts = numopts + 1
    LOOP UNTIL EOF(l)
    CLOSE #l

    DIM list$(numopts)

    '---------- load the list
    OPEN list$ FOR INPUT AS #l
    FOR n = 1 TO numopts
        LINE INPUT #l, list$(n)
    NEXT n
    CLOSE #l
 
 
    DIM buttonx(6), buttony(6), buttonxsize(6), buttonysize(6), buttonname$(6)
 
    '-----draw background
    x1 = 31 * xtextsize
    x2 = 49 * xtextsize
    y1 = 5 * ytextsize
    y2 = 20 * ytextsize
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), , B
    LINE (x1 + 1 * xtextsize, y1 + 3.5 * xtextsize)-(x2 - 1 * xtextsize, y2 - 2.5 * ytextsize), , B
    '-----names
    buttonname$(1) = "up.pic"
    buttonname$(2) = "down.pic"
    buttonname$(3) = "pgup.pic"
    buttonname$(4) = "pgdown.pic"
    buttonname$(5) = "okay.pic"
    buttonname$(6) = "cancel.pic"
    '-----locations
    buttonx(1) = 292: buttony(1) = 87
    buttonx(2) = 326: buttony(2) = 87
    buttonx(3) = 265: buttony(3) = 87
    buttonx(4) = 353: buttony(4) = 87
    buttonx(5) = 263: buttony(5) = 289
    buttonx(6) = 323: buttony(6) = 289

    f = FREEFILE
    FOR n = 1 TO 6
        DEF SEG = VARSEG(button(0))
        BLOAD buttonname$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
        DEF SEG
        PUT (buttonx(n), buttony(n)), button, PSET
    NEXT n

    showmouse
    offset = 1
    current.option = 1
    DO
        IF doneonce THEN
            LOCATE oldloc, 34: PRINT " "
            LOCATE oldloc, 47: PRINT " "
        ELSE
            doneonce = 1
        END IF
        '=========== draw the text on the menu
        IF current.option > offset + 9 THEN offset = current.option - 9
        IF current.option < offset THEN offset = current.option
        IF numopts > 9 THEN
            q = 9
        ELSE
            q = numopts - 1
        END IF
        showmouse
        FOR n = offset TO offset + q
            LOCATE 8 + n - offset, 35
            PRINT list$(n);
            FOR m = LEN(list$(n)) TO 12
                PRINT " ";
            NEXT m
            IF n = current.option THEN
                oldloc = 8 + n - offset
                LOCATE oldloc, 34: PRINT CHR$(26)
                LOCATE oldloc, 47: PRINT CHR$(27)
             
            END IF
        NEXT n
        showmouse
    
        DO
            keypressed$ = INKEY$
            bp = buttonpressed
            IF bp = 0 THEN letgo = 1
        LOOP UNTIL keypressed$ <> "" OR bp = 1
        '=========== handle mouse i/o
        x = mousex
        y = mousey
        IF bp = 1 THEN
            current.button = 0
            FOR n = 1 TO 6
                IF x > buttonx(n) AND x < buttonx(n) + buttonxsize(n) THEN
                    IF y > buttony(n) AND y < buttony(n) + buttonysize(n) THEN
                        current.button = n
                    END IF
                END IF
            NEXT n
            IF current.button = 0 THEN
                IF y >= 7 * ytextsize AND y < 18 * ytextsize THEN
                    n = INT(y / ytextsize) - 7
                END IF
                a = n + offset
                IF a <= numopts THEN
                    current.option = a
                    IF ct! < TIMER THEN
                        ct! = TIMER + .2
                        co = current.option
                        letgo = 0
                    ELSEIF letgo = 1 AND co = current.option THEN
                        gotone = 1
                    END IF
                END IF
            END IF

        END IF
     
        '=========== handle keyboard i/o
        SELECT CASE keypressed$
            CASE CHR$(0) + "H"
                current.button = 1
            CASE CHR$(0) + "P"
                current.button = 2
            CASE CHR$(0) + "I"
                current.button = 3
            CASE CHR$(0) + "Q"
                current.button = 4
            CASE CHR$(13)
                current.button = 5
            CASE CHR$(27)
                current.button = 6
        END SELECT
    
        '==================== do what the user says
        SELECT CASE current.button
            CASE 1
                IF current.option > 1 THEN current.option = current.option - 1
            CASE 2
                IF current.option < numopts THEN current.option = current.option + 1
            CASE 3
                IF current.option > 10 THEN
                    current.option = current.option - 10
                ELSE
                    current.option = 1
                END IF
            CASE 4
                IF current.option <= numopts - 10 THEN
                    current.option = current.option + 10
                ELSE
                    current.option = numopts
                END IF
            CASE 5
                gotone = 1
            CASE 6
                quit = 1
        END SELECT
    LOOP UNTIL quit OR gotone
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
    IF gotone THEN choose = list$(current.option)
END FUNCTION

SUB draw.grid
    FOR x = 0 TO xgridmax STEP gridsize
        LINE (x, 0)-(x, ygridmax)
    NEXT x
    FOR y = 0 TO ygridmax STEP gridsize
        LINE (B, y)-(xgridmax, y)
    NEXT y
END SUB

SUB drawscreen
    SCREEN 12: CLS
    PALETTE 0, 63 + 63 * 256 + 63 * 65536
    PALETTE 15, 0
    '======================== draw colours
    FOR y = 0 TO 15
        LINE (616, y * ytextsize)-(640, (y + 1) * ytextsize), y, BF
        LOCATE y + 1, 64
        SELECT CASE y
            CASE 0
                PRINT "Bright White"
            CASE 1
                PRINT "Blue"
            CASE 2
                PRINT "Green"
            CASE 3
                PRINT "Cyan"
            CASE 4
                PRINT "Red"
            CASE 5
                PRINT "Magenta"
            CASE 6
                PRINT "Brown"
            CASE 7
                PRINT "White"
            CASE 8
                PRINT "Grey"
            CASE 9
                PRINT "Bright Blue"
            CASE 10
                PRINT "Bright Green"
            CASE 11
                PRINT "Bright Cyan"
            CASE 12
                PRINT "Bright Red"
            CASE 13
                PRINT "Pink"
            CASE 14
                PRINT "Yellow"
            CASE 15
                PRINT "Black"
        END SELECT
        LINE (500, y * ytextsize)-(640, (y + 1) * ytextsize), 15, B
    NEXT y
    LINE (616, 0)-(616, y * ytextsize), 15
    '======================== draw grid
    draw.grid
    PUT (10, 300), picture, PSET
    FOR mapx = 0 TO xgridrange
        FOR mapy = 0 TO ygridrange
            map(mapx, mapy) = POINT(10 + mapx, 300 + mapy)
            IF map(mapx, mapy) <> 0 THEN
                LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), map(mapx, mapy), BF
                LINE (mapx * gridsize, mapy * gridsize)-((mapx + 1) * gridsize, (mapy + 1) * gridsize), , B
            END IF
        NEXT mapy
    NEXT mapx
    '======================== draw buttons
    LOCATE 1, 45: PRINT "Load Character"
    LOCATE 2, 45: PRINT "Save Character"
    LOCATE 3, 45: PRINT "New Character"
    LOCATE 4, 45: PRINT "Quit"
    LOCATE 5, 45: PRINT "Resize Grid"
    LOCATE 6, 45: PRINT "Point Mode"
    LOCATE 7, 45: PRINT "Box Mode"
    LINE (44 * xtextsize - 2, 0)-(58 * xtextsize, 7 * ytextsize), , B
    FOR y = 1 TO 6
        LINE (44 * xtextsize - 2, y * ytextsize)-(58 * xtextsize, y * ytextsize), , B
    NEXT y
END SUB

SUB load (name$)
    IF xmin <= xmax THEN
        GET (10 + xmin, 300 + ymin)-(10 + xmax, 300 + ymax), picture
    ELSE
        GET (11, 11)-(12, 12), picture
    END IF
    showmouse
    GET (10, 300)-(73, 355), picture
    CLS
    DEF SEG = VARSEG(picture(0))
    BLOAD name$, VARPTR(picture(0))
    drawscreen
    xmin = 1000
    ymin = 1000
    xmax = 0
    ymax = 0
    FOR x = 10 TO 10 + xgridrange - 1
        FOR y = 300 TO 300 + ygridrange - 1
            map(x - 10, y - 300) = POINT(x, y)
            IF map(x - 10, y - 300) <> 0 THEN
                IF xmin > x - 10 THEN xmin = x - 10
                IF ymin > y - 300 THEN ymin = y - 300
                IF xmax < x - 10 THEN xmax = x - 10
                IF ymax < y - 300 THEN ymax = y - 300
            END IF
        NEXT y
    NEXT x
    showmouse
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

SUB save
    showmouse
    IF xmin <= xmax THEN
        GET (10 + xmin, 300 + ymin)-(10 + xmax, 300 + ymax), picture
    ELSE
        GET (11, 11)-(12, 12), picture
    END IF
    name$ = taketext$("What would you like to call this character?")
    IF name$ <> "" THEN
        showmouse
        f = FREEFILE
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        okay = choice("junk", 2, "Are you sure?")
        showmouse
    END IF
    IF okay THEN
        '-----save picture
        DEF SEG = VARSEG(picture(0))
        BSAVE name$, VARPTR(picture(0)), 5266
    END IF
    showmouse
END SUB

SUB showmouse STATIC
    IF mouseon THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
    mouseon = 1 - mouseon
END SUB

FUNCTION taketext$ (text$)
    '==================================set values, draw window
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 31
                IF n < 127 THEN
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        showmouse
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
         
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, offset + 1, maxlength)
            END IF
            PRINT display.text$
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
        showmouse
    LOOP UNTIL ready OR cancel
    IF ready THEN taketext$ = text$
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue (text$)
    '==================================set values, draw window
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 47
                IF n < 58 AND LEN(text$) < maxlength THEN '--(text)
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
            showmouse
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, shift, maxlength)
            END IF
            PRINT display.text$

            'IF LEN(text$) <= maxlength THEN
            '    PRINT text$;
            'ELSE
            '    PRINT LEFT$(text$, maxlength);
            'END IF
            showmouse
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
    LOOP UNTIL ready OR cancel
    IF ready THEN takevalue = VAL(text$)
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

