DECLARE SUB flip.page (direction%)
DEFINT A-Z

'=============== declarations of subs
DECLARE SUB draw.icon (n%, c%)
DECLARE FUNCTION icons.touching% (n%, m%)
DECLARE SUB retitle.this.page ()
DECLARE SUB insert.a.page ()
DECLARE SUB remove.a.page ()
DECLARE SUB turn.to.page ()
DECLARE SUB add.a.page ()
DECLARE SUB load.page ()
DECLARE FUNCTION exists% (name$)
DECLARE FUNCTION choose$ (list$)
DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE SUB drawscreen ()
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION takevalue! (text$)
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE SUB showmouse ()
DECLARE SUB handle.option (option$)
DECLARE SUB close.a.menu ()
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB load.menus (filenum%)
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()

'======================= variables / types / constants
TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE
TYPE icontype
    x AS INTEGER
    y AS INTEGER
    xsize AS INTEGER
    ysize AS INTEGER
END TYPE
'----------- constants
CONST xtextsize = 8, ytextsize = 16
CONST zerox = 320, zeroy = 240
CONST flipx = 223, flipy = 0
DIM SHARED flipx2, flipxsize, flipysize

'----------- global variables
DIM SHARED icons
DIM SHARED icons.changed, menus.changed
icons = 0
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(15000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED picture2(2633), picture(2633), numpics, button(2633)
DIM SHARED current.page, pagename$, icon(icons) AS icontype, pagechanged
DIM SHARED numpages
'================= load data
'------------load menus
OPEN "gui.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 6), menumax(menus), menulength(menus)
xrange = 10
yrange = 10
load.menus (1)
CLOSE #1

'------------load page
IF exists("cpg.~~") THEN
    OPEN "cpg.~~" FOR INPUT AS #1
    INPUT #1, current.page
    CLOSE #1
ELSE
    current.page = 1
    SHELL ("echo 1 > cpg.~~")
END IF
IF exists("book.dat") THEN
    '------- count pages
    OPEN "book.dat" FOR INPUT AS #1
    WHILE NOT EOF(1)
        INPUT #1, a$
        IF a$ = "{" THEN numpages = numpages + 1
    WEND
    CLOSE #1
END IF

load.page

'------------load icons
icons = 1
'check.for.icons
REDIM SHARED icon(icons) AS icontype, iconname$(icons), icondata$(icons)
REDIM SHARED progname$(icons), progpath$(icons)

'=================================interrupts
'ON ERROR GOTO errhandle

'=========================Misc.
'------------set up graphics
SCREEN 12: CLS
PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0

'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
showmouse
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)

'------------draw the screen
drawscreen

'===============================main program==================================
DO
    IF pagechanged = 1 THEN
        pagechanged = 0
        load.page
        drawscreen
        'BEEP
    END IF
   
    '======================== mouse button pressed
    bp = buttonpressed
    mx = mousex
    my = mousey
    IF bp THEN
        IF my <= 15 THEN
            IF mx <= maximum.menux THEN
                '------- left button on the upper menus
                IF menu.open <> 0 THEN
                    close.a.menu
                END IF
                IF menu.open <> current.menu THEN
                    menu.open = current.menu
                    showmouse
                    open.a.menu (current.menu)
                    showmouse
                END IF
                DO: LOOP UNTIL buttonpressed = 0
            ELSE
                '--- page flipping buttons
                IF my >= flipy AND my <= flipy + flipysize THEN
                    IF mx >= flipx AND mx <= flipx + flipxsize THEN
                        flip.page (-1)
                    ELSEIF mx >= flipx2 AND mx <= flipx2 + flipxsize THEN
                        flip.page (1)
                    END IF
                END IF
            END IF
        ELSEIF on.a.menu AND menu.open <> 0 THEN
            handle.option (read.menu$)'----read.menu$ is a function
        ELSE
            '------- button pressed off the menus
            IF menu.open <> 0 THEN
                close.a.menu
                DO: LOOP UNTIL buttonpressed = 0
            ELSE ' (all menus are closed)
            END IF
        END IF
    END IF
LOOP UNTIL done
CLOSE
END
'===============================subroutines===================================
errhandle:
    RESUME NEXT

SUB add.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR APPEND AS #f
            PRINT #f, pn$
            PRINT #f, "{"
            PRINT #f, "}"
            CLOSE #f
        END IF
    END IF
END SUB

FUNCTION buttonpressed%
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

FUNCTION choice (filename$, icons, text$)
    '==================================set values, draw window
    DIM file$(icons), buttonxsize(icons), buttonysize(icons)
    DIM buttonx(icons), buttony(icons)
    '----- load the icon data
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    n = 0
    DEF SEG = VARSEG(button(0))
    FOR n = 1 TO icons
        INPUT #f, file$(n)
        BLOAD file$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
    NEXT n
    CLOSE #f

    '---- determine the necessary size of the window
    '--x
    tlen = LEN(text$)
    textx = 40 - INT(tlen / 2)
    FOR n = 1 TO icons
        xminsize = xminsize + buttonxsize(n) + 10
    NEXT n
    IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize
  
    '--y
    FOR n = 1 TO icons
        IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
    NEXT n
    yminsize = yminsize + 40

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE texty, textx: PRINT text$;

    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon positions

    '-- x
    a = xminsize
    FOR n = 1 TO icons
        a = a - buttonxsize(n)
    NEXT n
    a = a / (icons + 1)
    icx = 320 - (xminsize / 2)
    FOR n = 1 TO icons
        icx = icx + a
        buttonx(n) = icx
        icx = icx + buttonxsize(n)
    NEXT n

    '-- y
    a = y2 - (y1 + 2 * ytextsize)
    a = y2 - a / 2
    FOR n = 1 TO icons
        buttony(n) = a - buttonysize(n) / 2
    NEXT n
                          
    '----- load and draw the icons
    FOR n = 1 TO icons
        DEF SEG = VARSEG(button(0))
        BLOAD file$(n), VARPTR(button(0))
        PUT (buttonx(n), buttony(n)), button
    NEXT n
    DEF SEG

    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            FOR n = 1 TO icons
                IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
                    IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
                        choice = n
                        gotone = n
                    END IF
                END IF
            NEXT n
        END IF
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
END FUNCTION

FUNCTION choose$ (list$)
    l = FREEFILE

    '---------- check for listsize
    OPEN list$ FOR INPUT AS #l
    DO
        LINE INPUT #l, junk$
        numopts = numopts + 1
    LOOP UNTIL EOF(l)
    CLOSE #l

    DIM list$(numopts)

    '---------- load the list
    OPEN list$ FOR INPUT AS #l
    FOR n = 1 TO numopts
        LINE INPUT #l, list$(n)
    NEXT n
    CLOSE #l


    DIM buttonx(6), buttony(6), buttonxsize(6), buttonysize(6), buttonname$(6)

    '-----draw background
    x1 = 31 * xtextsize
    x2 = 49 * xtextsize
    y1 = 5 * ytextsize
    y2 = 20 * ytextsize
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), , B
    LINE (x1 + 1 * xtextsize, y1 + 3.5 * xtextsize)-(x2 - 1 * xtextsize, y2 - 2.5 * ytextsize), , B
    '-----names
    buttonname$(1) = "up.pic"
    buttonname$(2) = "down.pic"
    buttonname$(3) = "pgup.pic"
    buttonname$(4) = "pgdown.pic"
    buttonname$(5) = "okay.pic"
    buttonname$(6) = "cancel.pic"
    '-----locations
    buttonx(1) = 292: buttony(1) = 87
    buttonx(2) = 326: buttony(2) = 87
    buttonx(3) = 265: buttony(3) = 87
    buttonx(4) = 353: buttony(4) = 87
    buttonx(5) = 263: buttony(5) = 289
    buttonx(6) = 323: buttony(6) = 289

    f = FREEFILE
    FOR n = 1 TO 6
        DEF SEG = VARSEG(button(0))
        BLOAD buttonname$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
        DEF SEG
        PUT (buttonx(n), buttony(n)), button, PSET
    NEXT n

    showmouse
    offset = 1
    current.option = 1
    DO
        IF doneonce THEN
            LOCATE oldloc, 34: PRINT " "
            LOCATE oldloc, 47: PRINT " "
        ELSE
            doneonce = 1
        END IF
        '=========== draw the text on the menu
        IF current.option > offset + 9 THEN offset = current.option - 9
        IF current.option < offset THEN offset = current.option
        IF numopts > 9 THEN
            q = 9
        ELSE
            q = numopts - 1
        END IF
        showmouse
        FOR n = offset TO offset + q
            LOCATE 8 + n - offset, 35
            PRINT list$(n);
            FOR m = LEN(list$(n)) TO 12
                PRINT " ";
            NEXT m
            IF n = current.option THEN
                oldloc = 8 + n - offset
                LOCATE oldloc, 34: PRINT CHR$(26)
                LOCATE oldloc, 47: PRINT CHR$(27)
           
            END IF
        NEXT n
        showmouse
  
        DO
            keypressed$ = INKEY$
            bp = buttonpressed
            IF bp = 0 THEN letgo = 1
        LOOP UNTIL keypressed$ <> "" OR bp = 1
        '=========== handle mouse i/o
        x = mousex
        y = mousey
        IF bp = 1 THEN
            current.button = 0
            FOR n = 1 TO 6
                IF x > buttonx(n) AND x < buttonx(n) + buttonxsize(n) THEN
                    IF y > buttony(n) AND y < buttony(n) + buttonysize(n) THEN
                        current.button = n
                    END IF
                END IF
            NEXT n
            IF current.button = 0 THEN
                IF y >= 7 * ytextsize AND y < 18 * ytextsize THEN
                    n = INT(y / ytextsize) - 7
                END IF
                a = n + offset
                IF a <= numopts THEN
                    current.option = a
                    IF ct! < TIMER THEN
                        ct! = TIMER + .2
                        co = current.option
                        letgo = 0
                    ELSEIF letgo = 1 AND co = current.option THEN
                        gotone = 1
                    END IF
                END IF
            END IF

        END IF
   
        '=========== handle keyboard i/o
        SELECT CASE keypressed$
            CASE CHR$(0) + "H"
                current.button = 1
            CASE CHR$(0) + "P"
                current.button = 2
            CASE CHR$(0) + "I"
                current.button = 3
            CASE CHR$(0) + "Q"
                current.button = 4
            CASE CHR$(13)
                current.button = 5
            CASE CHR$(27)
                current.button = 6
        END SELECT
  
        '==================== do what the user says
        SELECT CASE current.button
            CASE 1
                IF current.option > 1 THEN current.option = current.option - 1
            CASE 2
                IF current.option < numopts THEN current.option = current.option + 1
            CASE 3
                IF current.option > 10 THEN
                    current.option = current.option - 10
                ELSE
                    current.option = 1
                END IF
            CASE 4
                IF current.option <= numopts - 10 THEN
                    current.option = current.option + 10
                ELSE
                    current.option = numopts
                END IF
            CASE 5
                gotone = 1
            CASE 6
                quit = 1
        END SELECT
    LOOP UNTIL quit OR gotone
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
    IF gotone THEN choose = list$(current.option)
END FUNCTION

SUB close.a.menu '(menu.index)
    showmouse
    'PUT (xtextsize * menumax(old.menu.index - 1), ytextsize), background, PSET
    PUT (minmenx, minmeny), background, PSET
    showmouse
    menu.open = 0
END SUB

FUNCTION current.menu
    FOR n = 1 TO menus
        IF mousex < menumax(n) * xtextsize THEN EXIT FOR
    NEXT n
    IF n > menus THEN n = menus
    current.menu = n
END FUNCTION

SUB drag.icon
    n = current.icon
    x = mousex
    y = mousey

    x1 = icon(n).x
    y1 = icon(n).y
    x2 = icon(n).x + icon(n).xsize
    y2 = icon(n).y + icon(n).ysize
    xoffset = x - x1
    yoffset = y - y1
    showmouse
    draw.icon n, 0
    PUT (x1, y1), picture
    showmouse
    doneonce = 0
    DO
        IF (oldmousex <> mousex OR oldmousey <> mousey) AND doneonce = 1 THEN
            x = mousex
            y = mousey
            oldmousex = x
            oldmousey = y
            x1 = x - xoffset
            y1 = y - yoffset
      
            '=========account for walls
            IF x1 > xscreensize - icon(n).xsize THEN
                x1 = xscreensize - icon(n).xsize
                x2 = xscreensize
                xoffset = x - x1
            END IF
            IF y1 > yscreensize - icon(n).ysize THEN
                y1 = yscreensize - icon(n).ysize
                y2 = yscreensize
                yoffset = y - y1
            END IF
            IF x1 < 0 THEN
                x1 = 0
                x2 = icon(n).xsize
                xoffset = x - x1
            END IF
            IF y1 < 0 THEN
                y1 = 0
                y2 = icon(n).ysize
                yoffset = y - y1
            END IF
            IF y1 < ytextsize + 2 THEN
                y1 = ytextsize + 2
                y2 = y1 + icon(n).ysize
                yoffset = y - y1
            END IF
            '=============draw the icon if moving
            showmouse
            PUT (oldx, oldy), picture2, PSET
            GET (x1, y1)-(x1 + icon(n).xsize, y1 + icon(n).ysize), picture2
            icon(n).x = x1
            icon(n).y = y1
            draw.icon n, 2
            showmouse
        ELSEIF doneonce = 0 THEN
            doneonce = 1
            showmouse
            FOR m = 1 TO icons
                IF n <> m THEN
                    IF icons.touching(n, m) THEN draw.icon m, 1
                END IF
            NEXT m
            draw.icon n, 0
            GET (x1, y1)-(x1 + icon(n).xsize, y1 + icon(n).ysize), picture2
            showmouse
            icon(n).x = x1
            icon(n).y = y1
        END IF
        oldx = x1
        oldy = y1

    LOOP UNTIL buttonpressed = 0
    showmouse
    draw.icon n, 1
    showmouse
END SUB

SUB draw.icon (n, c)
    SELECT CASE c
        CASE 0    '-----loads
            DEF SEG = VARSEG(picture(0))
            BLOAD iconname$(n), VARPTR(picture(0))
            DEF SEG
    
        CASE 1 '----- loads and draws
            DEF SEG = VARSEG(picture(0))
            BLOAD iconname$(n), VARPTR(picture(0))
            DEF SEG
            a = icon(n).x
            B = icon(n).y
            c = icon(n).x + icon(n).xsize
            d = icon(n).y + icon(n).ysize
            PUT (a, B), picture, PSET

        CASE 2 '------ draws
            a = icon(n).x
            B = icon(n).y
            c = icon(n).x + icon(n).xsize
            d = icon(n).y + icon(n).ysize
            PUT (a, B), picture, PSET
    END SELECT
END SUB

SUB drawscreen
    '========================draw.menus
    showmouse
    CLS
    n = 1
    menumax(0) = 1
    FOR a = 1 TO menus
        IF a = 1 THEN shift = 0
        n = n + LEN(menu$(a, 0)) + 4
        menumax(a) = n
        LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
        LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
    NEXT a
  
    LOCATE 1, 60 - INT(LEN(pagename$) / 2)
    PRINT pagename$
   
    '========= draw the flip buttons
    DEF SEG = VARSEG(button(0))
    BLOAD "flipl.pic", VARPTR(button(0))
    PUT (flipx, flipy), button, PSET
    flipxsize = button(0)
    flipysize = button(1)
    DEF SEG = VARSEG(button(0))
    BLOAD "flipr.pic", VARPTR(button(0))
    flipx2 = flipx + flipxsize + 5
    PUT (flipx2, flipy), button, PSET

    maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
    LINE (0, ytextsize)-(640, ytextsize)
    LINE (0, ytextsize - 2)-(maximum.menux, ytextsize - 2)
   
    showmouse
END SUB

FUNCTION exists (name$)
    SHELL ("dir/b/o " + name$ + " > junk")
    f = FREEFILE
    OPEN "junk" FOR INPUT AS #f
    ok = 0
    IF NOT EOF(f) THEN ok = 1
    CLOSE #f
    exists = ok
END FUNCTION

SUB flip.page (direction)
    np = current.page + direction
    IF np >= 1 AND np <= numpages THEN
        current.page = np
        pagechanged = 1
    END IF
END SUB

SUB handle.option (option$)
    SELECT CASE option$
        CASE "Exit"
            close.a.menu
            n = FREEFILE
            OPEN "junk" FOR OUTPUT AS #n
            PRINT #n, "Yes.pic"
            PRINT #n, "no.pic"
            CLOSE #n
            IF choice("junk", 2, "Are you sure you want to exit?") = 1 THEN
                done = 1
            END IF
        CASE "DOS Shell"
            close.a.menu
            showmouse
            SCREEN 0
            SHELL
            SCREEN 12
            showmouse
            PALETTE 0, 63 + 63 * 256 + 63 * 65536
            PALETTE 15, 0
            drawscreen
        CASE "Add a Page"
            close.a.menu
            add.a.page
        CASE "Turn to Page..."
            close.a.menu
            turn.to.page
        CASE "Remove a Page"
            close.a.menu
            remove.a.page
        CASE "Insert a Page"
            close.a.menu
            insert.a.page
        CASE "Retitle this Page"
            close.a.menu
            retitle.this.page
    END SELECT
END SUB

FUNCTION icons.touching (n, m)
    a = icon(m).x
    B = icon(m).y
    c = a + icon(m).xsize
    d = B + icon(m).ysize

    x1 = icon(n).x
    y1 = icon(n).y
    x2 = x1 + icon(n).xsize
    y2 = y1 + icon(n).ysize

    c1 = (a >= x1 AND a <= x2)
    c2 = (c >= x1 AND c <= x2)
    c3 = (B >= y1 AND B <= y2)
    c4 = (d >= y1 AND d <= y2)
    c5 = (a <= x1 AND c >= x2)
    c6 = (B <= y1 AND d >= y2)

    IF (c1 OR c2 OR c5) AND (c3 OR c4 OR c6) THEN icons.touching = 1
END FUNCTION

SUB insert.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            DO
                INPUT #f, a$
                IF a$ = pagename$ THEN
                    PRINT #g, pn$
                    PRINT #g, "{"
                    PRINT #g, "}"
                END IF
                PRINT #g, a$
            LOOP UNTIL EOF(f)
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            pagename$ = pn$
            drawscreen
        END IF
    END IF
END SUB

SUB load.menus (filenum)
    FOR n = 1 TO menus
        INPUT #filenum, menu$(n, 0)
        INPUT #filenum, menulength(n)
        maximum.menux = maximum.menux + LEN(menu$(n, 0))
        FOR a = 1 TO menulength(n)
            INPUT #filenum, menu$(n, a)
        NEXT a
    NEXT n
    maximum.menux = maximum.menux * xtextsize
END SUB

SUB load.page
    f = FREEFILE
    IF exists("book.dat") THEN
        '============== find the current.page
        OPEN "book.dat" FOR INPUT AS #f
        fini = 0: pagesfound = 0
        WHILE NOT (EOF(f) OR fini = 1)
            B$ = a$
            INPUT #f, a$
            IF a$ = "{" THEN pagesfound = pagesfound + 1
            IF pagesfound = current.page THEN
                '================== find data on current page
                fini = 1
                pagename$ = B$

            END IF
        WEND
        CLOSE #f
    ELSE
        OPEN "book.dat" FOR OUTPUT AS #f
        PRINT #f, "GuiJe"
        PRINT #f, "{"
        PRINT #f, "}"
        CLOSE #f
        '====================== Create data for title page
        pagename$ = "GuiJe"

    END IF
END SUB

SUB message (filename$, iconname$)
    DIM background2(15000), background3(15000), background4(15000)
    '============= check the length & maxwidth of the file
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    maxwidth = 0
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        IF LEN(a$) > maxwidth THEN maxwidth = LEN(a$)
        numlines = numlines + 1
    WEND
    CLOSE #f
    '==================================set values, draw window
    '----- load the icon data
    DEF SEG = VARSEG(button(0))
    BLOAD iconname$, VARPTR(button(0))
    buttonxsize = button(0)
    buttonysize = button(1)
   
    '==================================set values, draw window

    '---- determine the necessary size of the window
    '--x
    textx = 40 - INT(maxwidth / 2)
    xminsize = (maxwidth + 3) * xtextsize
 
    '--y
    yminsize = numlines * ytextsize + buttonysize + 20

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    mx = x1 + (x2 - x1) / 2
    my = y1 + (y2 - y1) / 2
    GET (x1, y1)-(mx, my), background
    GET (mx + 1, y1)-(x2, my), background2
    GET (x1, my + 1)-(mx, y2), background3
    GET (mx + 1, my + 1)-(x2, y2), background4
    LINE (x1, y1)-(x2, y2), 0, BF

    OPEN filename$ FOR INPUT AS #f
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        LOCATE texty + lnum, textx + (maxwidth - LEN(a$)) / 2
        lnum = lnum + 1
        PRINT a$
    WEND
    CLOSE #f
    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon position
    buttonx = 320 - button(0) / 2
    buttony = y2 - (button(1) + 5)

    '------- draw the icon
    PUT (buttonx, buttony), button
   
    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            IF x >= buttonx AND x <= buttonx + buttonxsize THEN
                IF y >= buttony AND y <= buttony + buttonysize THEN
                    gotone = 1
                END IF
            END IF
        END IF
        IF INKEY$ <> "" THEN gotone = 1
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    PUT (mx + 1, y1), background2, PSET
    PUT (x1, my + 1), background3, PSET
    PUT (mx + 1, my + 1), background4, PSET
    showmouse
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

FUNCTION on.a.menu
    q = 0
    IF mousex > minmenx AND mousex < maxmenx THEN
        IF mousey > minmeny AND mousey < maxmeny THEN
             q = 1
        END IF
    END IF
    on.a.menu = q
END FUNCTION

SUB open.a.menu (menu.index)

    '--------- determine width
    menuwidth = 0
    FOR n = 1 TO menulength(menu.index)
        cwidth = LEN(menu$(menu.index, n))
        IF cwidth > menuwidth THEN menuwidth = cwidth
    NEXT n

    '--------- get screen
    minmenx = xtextsize * menumax(menu.index - 1) - xtextsize
    minmeny = ytextsize - ytextsize / 4
    maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + xtextsize
    maxmeny = menulength(menu.index) * ytextsize + minmeny + ytextsize / 2
    GET (minmenx, minmeny)-(maxmenx, maxmeny), background
    PUT (minmenx, minmeny), background
    old.menu.index = menu.index

    '--------- print text
    FOR n = 1 TO menulength(menu.index)
        LOCATE 1 + n, menumax(menu.index - 1) + 1
        PRINT menu$(menu.index, n)
    NEXT n

    '--------- separate text with dotted line
    FOR n = 2 TO menulength(menu.index)
        LINE (minmenx, n * ytextsize)-(maxmenx, n * ytextsize), 8, , 21845
    NEXT n

    '--------- draw edge of menu
    LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
    LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
    LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1), 7
    LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1), 7
    LINE (minmenx + 1, maxmeny - 1)-(maxmenx - 1, maxmeny - 1), 8
    LINE (maxmenx - 1, maxmeny - 1)-(maxmenx - 1, minmeny + 1), 8
    PSET (minmenx, minmeny), 0
    PSET (minmenx, maxmeny), 0
    PSET (maxmenx, minmeny), 0
    PSET (maxmenx, maxmeny), 0
    PSET (minmenx + 1, minmeny + 1)
    PSET (minmenx + 1, maxmeny - 1)
    PSET (maxmenx - 1, minmeny + 1)
    PSET (maxmenx - 1, maxmeny - 1)

END SUB

FUNCTION read.menu$
    y = mousey
    selection = 0
    FOR n = 1 TO menulength(old.menu.index)
        IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
            selection = n
        END IF
    NEXT n
    read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB remove.a.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        B$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(B$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    pn$ = choose$("junk")

    '============= confirm removal of page
    OPEN "junk" FOR OUTPUT AS #f
    PRINT #f, "okay.pic"
    PRINT #f, "cancel.pic"
    CLOSE #f
    IF choice("junk", 2, "All data for this page will be removed.") = 1 THEN
        '============== remove the page
        OPEN "book.dat" FOR INPUT AS #f
        OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF LEFT$(a$, 12) <> pn$ THEN
                PRINT #g, a$
            ELSE
                DO
                    INPUT #f, a$
                LOOP UNTIL a$ = "}"
            END IF
        WEND
        CLOSE g, f
        KILL "book.dat"
        SHELL "rename junk book.dat"
        numpages = numpages - 1
       
        IF pn$ = pagename$ THEN
            current.page = 1
            load.page
            drawscreen
        END IF
    END IF
END SUB

SUB retitle.this.page
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
        g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF a$ = pagename$ THEN
                PRINT #g, pn$
            ELSE
                PRINT #g, a$
            END IF
        WEND
        pagename$ = pn$
        CLOSE f, g
        KILL "book.dat"
        SHELL "rename junk book.dat"
        drawscreen
    END IF
END SUB

SUB showmouse STATIC
    IF mouseon THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
    mouseon = 1 - mouseon
END SUB

FUNCTION taketext$ (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 31
                IF n < 127 THEN
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        showmouse
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
         
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, offset + 1, maxlength)
            END IF
            PRINT display.text$
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
        showmouse
    LOOP UNTIL ready OR cancel
    IF ready THEN taketext$ = text$
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue! (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE ELSE
                IF ((n = 45) OR (n = 46) OR ((n < 58) AND (n > 47))) AND LEN(text$) < maxlength THEN '--(text)
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
            showmouse
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, shift, maxlength)
            END IF
            PRINT display.text$

            'IF LEN(text$) <= maxlength THEN
            '    PRINT text$;
            'ELSE
            '    PRINT LEFT$(text$, maxlength);
            'END IF
            showmouse
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
    LOOP UNTIL ready OR cancel
    IF ready THEN takevalue! = VAL(text$)
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

SUB turn.to.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        B$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(B$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    a$ = choose$("junk")
   
    IF a$ <> "" THEN
        pagename$ = a$
        '============= get the page number
        OPEN "junk" FOR INPUT AS #f
        current.page = 0
        DO
            INPUT #f, a$
            current.page = current.page + 1
        LOOP UNTIL a$ = pagename$
        CLOSE #f
        drawscreen
    END IF
END SUB

