DEFINT A-Z

'=============== declarations of subs
DECLARE SUB browse ()
DECLARE SUB alter.icon.properties ()
DECLARE SUB remove.an.icon ()
DECLARE SUB savepage ()
DECLARE SUB add.an.icon ()
DECLARE SUB handle.icon (c.i%)
DECLARE FUNCTION double.click% ()
DECLARE SUB drag.icon ()
DECLARE SUB drawicons ()
DECLARE SUB load.icons ()
DECLARE FUNCTION current.icon% ()
DECLARE SUB count.icons ()
DECLARE SUB flip.page (direction%)
DECLARE SUB draw.icon (n%, c%)
DECLARE FUNCTION icons.touching% (n%, m%)
DECLARE SUB retitle.this.page ()
DECLARE SUB insert.a.page ()
DECLARE SUB remove.a.page ()
DECLARE SUB turn.to.page ()
DECLARE SUB add.a.page ()
DECLARE SUB load.page ()
DECLARE FUNCTION exists% (name$)
DECLARE FUNCTION choose$ (list$)
DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE SUB drawscreen ()
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION takevalue! (text$)
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE SUB showmouse ()
DECLARE SUB handle.option (option$)
DECLARE SUB close.a.menu ()
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB load.menus (filenum%)
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()

'======================= variables / types / constants
TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE
TYPE icontype
    x AS INTEGER
    y AS INTEGER
    xsize AS INTEGER
    ysize AS INTEGER
END TYPE
'----------- constants
CONST xscreensize = 640, yscreensize = 480
CONST xtextsize = 8, ytextsize = 16
CONST zerox = 320, zeroy = 240
CONST flipx = 223, flipy = 0
CONST click.speed = .2
CONST default.icon.x = 100, default.icon.y = 100
DIM SHARED flipx2, flipxsize, flipysize

'----------- global variables
DIM SHARED icons
DIM SHARED icons.changed, menus.changed
icons = 0
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(15000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED picture2(2633), picture(2633), numpics, button(2633)
DIM SHARED current.page, pagename$, icon(icons) AS icontype, pagechanged
DIM SHARED numpages
'================= load data
'------------load menus
OPEN "gui.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 6), menumax(menus), menulength(menus)
xrange = 10
yrange = 10
load.menus (1)
CLOSE #1

'------------load page
IF exists("cpg.~~") THEN
    OPEN "cpg.~~" FOR INPUT AS #1
    INPUT #1, current.page
    CLOSE #1
ELSE
    current.page = 1
    SHELL ("echo 1 > cpg.~~")
END IF
IF exists("book.dat") THEN
    '------- count pages
    OPEN "book.dat" FOR INPUT AS #1
    WHILE NOT EOF(1)
        INPUT #1, a$
        IF a$ = "{" THEN numpages = numpages + 1
    WEND
    CLOSE #1
END IF

load.page
'------------load icons
count.icons
REDIM SHARED icon(icons) AS icontype, iconname$(icons)
REDIM SHARED progname$(icons), progpath$(icons)
load.icons

'=================================interrupts
'ON ERROR GOTO errhandle

'=========================Misc.
'------------set up graphics
SCREEN 12: CLS
PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0

'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
showmouse
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)

'------------draw the screen
drawscreen
drawicons

'===============================main program==================================
DO
    IF pagechanged = 1 OR icons.changed = 1 THEN
        icons.changed = 0
        pagechanged = 0
        load.page
        drawscreen
        count.icons
        REDIM SHARED icon(icons) AS icontype, iconname$(icons)
        REDIM SHARED progname$(icons), progpath$(icons)
        load.icons
        drawicons
    END IF
  
    d.c = double.click

    '======================== mouse button pressed
    bp = buttonpressed
    mx = mousex
    my = mousey
    IF bp THEN
        IF my <= 15 THEN
            IF mx <= maximum.menux THEN
                '------- left button on the upper menus
                IF menu.open <> 0 THEN
                    close.a.menu
                END IF
                IF menu.open <> current.menu THEN
                    menu.open = current.menu
                    showmouse
                    open.a.menu (current.menu)
                    showmouse
                END IF
                DO: LOOP UNTIL buttonpressed = 0
            ELSE
                '--- page flipping buttons
                IF my >= flipy AND my <= flipy + flipysize THEN
                    IF mx >= flipx AND mx <= flipx + flipxsize THEN
                        savepage
                        flip.page (-1)
                    ELSEIF mx >= flipx2 AND mx <= flipx2 + flipxsize THEN
                        savepage
                        flip.page (1)
                    END IF
                END IF
            END IF
        ELSEIF on.a.menu AND menu.open <> 0 THEN
            handle.option (read.menu$)'----read.menu$ is a function
        ELSE
            '------- button pressed off the menus
            IF menu.open <> 0 THEN
                close.a.menu
                DO: LOOP UNTIL buttonpressed = 0
            ELSE ' (all menus are closed)
                c.i = current.icon
                IF c.i <> 0 THEN
                    IF d.c <> 0 THEN
                        handle.icon (c.i)
                    ELSEIF buttonpressed = 2 THEN
                        drag.icon
                    END IF
                END IF
            END IF
        END IF
    END IF
LOOP UNTIL done
savepage
f = FREEFILE: OPEN "cpg.~~" FOR OUTPUT AS #f
PRINT #f, current.page
CLOSE #f
CLOSE
END
'===============================subroutines===================================
errhandle:
    RESUME NEXT

SUB add.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR APPEND AS #f
            PRINT #f, pn$
            PRINT #f, "{"
            PRINT #f, "}"
            CLOSE #f
            numpages = numpages + 1
        END IF
    END IF
    current.page = numpages
    pagechanged = 1
    icons.changed = 1
END SUB

SUB add.an.icon
    f = FREEFILE
    SHELL "dir/o/b *.pic > junk"
    i.n$ = choose$("junk")
    yup = 0
    IF i.n$ <> "" THEN
        prg$ = taketext$("What program will this icon start?")
        IF prg$ <> "" THEN
            pth$ = taketext$("What is the search path for this program?")
            IF pth$ = "" THEN
                SHELL "cd > junk"
                OPEN "junk" FOR INPUT AS #f
                INPUT #f, pth$
                CLOSE #f
            END IF
            OPEN "junk" FOR OUTPUT AS #f
            PRINT #f, "yes.pic"
            PRINT #f, "no.pic"
            CLOSE #f
            yup = choice("junk", 2, "Are you sure?")
        END IF
    END IF

    IF yup = 1 THEN
        savepage
        OPEN "book.dat" FOR INPUT AS #f
        g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
        b$ = ""
        WHILE NOT EOF(f)
            b$ = a$
            INPUT #f, a$
            PRINT #g, a$
            IF b$ = pagename$ THEN
                PRINT #g, i.n$
                PRINT #g, "["
                PRINT #g, default.icon.x
                PRINT #g, default.icon.y
                PRINT #g, prg$
                PRINT #g, pth$
                PRINT #g, "]"
            END IF
        WEND
        CLOSE f, g
        KILL "book.dat"
        SHELL "rename junk book.dat"
        icons.changed = 1
    END IF
END SUB

SUB alter.icon.properties
    f = FREEFILE
    OPEN "junk" FOR OUTPUT AS #f
    FOR n = 1 TO icons
        PRINT #f, iconname$(n)
    NEXT n
    CLOSE #f
    c$ = choose$("junk")
    IF c$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "Are you sure?") = 1 THEN
           
            DO
                prg$ = taketext$("What program will this icon start?")
            LOOP UNTIL prg$ <> ""
            pth$ = taketext$("What is the search path for this program?")
            IF pth$ = "" THEN
                SHELL "cd > junk"
                OPEN "junk" FOR INPUT AS #f
                INPUT #f, pth$
                CLOSE #f
            END IF
           
            savepage
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            yup = 0
            WHILE NOT EOF(f)
                INPUT #f, a$
                PRINT #g, a$
                IF a$ = c$ AND yup = 0 THEN
                    yup = 1
                    INPUT #f, a$  '[
                    INPUT #f, ix
                    INPUT #f, iy
                    DO
                        INPUT #f, a$
                    LOOP UNTIL a$ = "]"
                    '=========== add stuff here
                    PRINT #g, "["
                    PRINT #g, ix
                    PRINT #g, iy
                    PRINT #g, prg$
                    PRINT #g, pth$
                    PRINT #g, "]"
                END IF
            WEND
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            icons.changed = 1
        END IF
    END IF
END SUB

SUB browse
    f = FREEFILE
    SHELL "cd > junk"
    OPEN "junk" FOR INPUT AS #f
    INPUT #f, oldpth$
    CLOSE #f
    newpth$ = oldpth$

    DO
        '================ compose the list of files into "junk"
        SHELL "dir/a:-d/b/o " + newpth$ + "\*.* > junk"
        SHELL "dir/a:d/b/o " + newpth$ + "\*.* > !@#$%^&"
        OPEN "junk" FOR APPEND AS #f
        g = FREEFILE: OPEN "!@#$%^&" FOR INPUT AS #g
        PRINT #f, "[..]"
        WHILE NOT EOF(g)
            INPUT #g, a$
            PRINT #f, "["; a$; "]"
        WEND
        CLOSE f, g
        KILL "!@#$%^&"
        a$ = choose$("junk")
        SELECT CASE LEFT$(a$, 1)
            CASE "["
                d$ = MID$(a$, 2, LEN(a$) - 2)
                SELECT CASE d$
                    CASE ".."
                        m = LEN(newpth$)
                        DO
                            a$ = MID$(newpth$, m, 1)
                            m = m - 1
                        LOOP UNTIL a$ = "\"
                        newpth$ = LEFT$(newpth$, m)
                    CASE ELSE
                        newpth$ = newpth$ + "\" + d$
                END SELECT
            CASE ""
                fini = 1
                newpth$ = oldpth$
                runprog$ = ""
            CASE ELSE
                fini = 1
                runprog$ = a$
        END SELECT
    LOOP UNTIL fini = 1
   
    '================================= run the chosen program
    'newpth$, runprog$
    SELECT CASE UCASE$(RIGHT$(runprog$, 4))
        CASE ".BAT", ".EXE", ".COM"
            OPEN "junk" FOR OUTPUT AS #f
            PRINT #f, "yes.pic"
            PRINT #f, "no.pic"
            CLOSE #f
            IF choice("junk", 2, "You want to run the program " + CHR$(34) + runprog$ + CHR$(34) + "?") THEN
                OPEN "execute.bat" FOR OUTPUT AS #f
                PRINT #f, "@echo off"
                PRINT #f, "cd "; newpth$
                IF UCASE$(RIGHT$(runprog$, 4)) = ".BAT" THEN
                    PRINT #f, "call " + runprog$
                ELSE
                    PRINT #f, runprog$
                END IF
                PRINT #f, "cd "; oldpth$
                PRINT #f, "gui.bat"
                CLOSE #f
                done = 1
            END IF
        CASE ELSE
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "To run a program it must be of the type " + CHR$(34) + ".exe" + CHR$(34) + ", " + CHR$(34) + ".com" + CHR$(34) + ", or " + CHR$(34) + ".bat" + CHR$(34) + ".")
    END SELECT
END SUB

FUNCTION buttonpressed%
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

FUNCTION choice (filename$, numicons, text$)
    '==================================set values, draw window
    DIM file$(numicons), buttonxsize(numicons), buttonysize(numicons)
    DIM buttonx(numicons), buttony(numicons)
    '----- load the icon data
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    n = 0
    DEF SEG = VARSEG(button(0))
    FOR n = 1 TO numicons
        INPUT #f, file$(n)
        BLOAD file$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
    NEXT n
    CLOSE #f

    '---- determine the necessary size of the window
    '--x
    tlen = LEN(text$)
    textx = 40 - INT(tlen / 2)
    FOR n = 1 TO numicons
        xminsize = xminsize + buttonxsize(n) + 10
    NEXT n
    IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize
  
    '--y
    FOR n = 1 TO numicons
        IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
    NEXT n
    yminsize = yminsize + 40

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE texty, textx: PRINT text$;

    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon positions

    '-- x
    a = xminsize
    FOR n = 1 TO numicons
        a = a - buttonxsize(n)
    NEXT n
    a = a / (numicons + 1)
    icx = 320 - (xminsize / 2)
    FOR n = 1 TO numicons
        icx = icx + a
        buttonx(n) = icx
        icx = icx + buttonxsize(n)
    NEXT n

    '-- y
    a = y2 - (y1 + 2 * ytextsize)
    a = y2 - a / 2
    FOR n = 1 TO numicons
        buttony(n) = a - buttonysize(n) / 2
    NEXT n
                          
    '----- load and draw the numicons
    FOR n = 1 TO numicons
        DEF SEG = VARSEG(button(0))
        BLOAD file$(n), VARPTR(button(0))
        PUT (buttonx(n), buttony(n)), button
    NEXT n
    DEF SEG

    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            FOR n = 1 TO numicons
                IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
                    IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
                        choice = n
                        gotone = n
                    END IF
                END IF
            NEXT n
        END IF
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
END FUNCTION

FUNCTION choose$ (list$)
    l = FREEFILE

    '---------- check for listsize
    OPEN list$ FOR INPUT AS #l
    WHILE NOT EOF(l)
        LINE INPUT #l, junk$
        numopts = numopts + 1
    WEND
    CLOSE #l

    DIM list$(numopts)

    '---------- load the list
    OPEN list$ FOR INPUT AS #l
    FOR n = 1 TO numopts
        LINE INPUT #l, list$(n)
    NEXT n
    CLOSE #l


    DIM buttonx(6), buttony(6), buttonxsize(6), buttonysize(6), buttonname$(6)

    '-----draw background
    x1 = 31 * xtextsize
    x2 = 49 * xtextsize
    y1 = 5 * ytextsize
    y2 = 20 * ytextsize
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), , B
    LINE (x1 + 1 * xtextsize, y1 + 3.5 * xtextsize)-(x2 - 1 * xtextsize, y2 - 2.5 * ytextsize), , B
    '-----names
    buttonname$(1) = "up.pic"
    buttonname$(2) = "down.pic"
    buttonname$(3) = "pgup.pic"
    buttonname$(4) = "pgdown.pic"
    buttonname$(5) = "okay.pic"
    buttonname$(6) = "cancel.pic"
    '-----locations
    buttonx(1) = 292: buttony(1) = 87
    buttonx(2) = 326: buttony(2) = 87
    buttonx(3) = 265: buttony(3) = 87
    buttonx(4) = 353: buttony(4) = 87
    buttonx(5) = 263: buttony(5) = 289
    buttonx(6) = 323: buttony(6) = 289

    f = FREEFILE
    FOR n = 1 TO 6
        DEF SEG = VARSEG(button(0))
        BLOAD buttonname$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
        DEF SEG
        PUT (buttonx(n), buttony(n)), button, PSET
    NEXT n

    showmouse
    offset = 1
    current.option = 1
    DO
        IF doneonce THEN
            LOCATE oldloc, 34: PRINT " "
            LOCATE oldloc, 47: PRINT " "
        ELSE
            doneonce = 1
        END IF
        '=========== draw the text on the menu
        IF current.option > offset + 9 THEN offset = current.option - 9
        IF current.option < offset THEN offset = current.option
        IF numopts > 9 THEN
            q = 9
        ELSE
            q = numopts - 1
        END IF
        showmouse
        FOR n = offset TO offset + q
            LOCATE 8 + n - offset, 35
            PRINT list$(n);
            FOR m = LEN(list$(n)) TO 12
                PRINT " ";
            NEXT m
            IF n = current.option THEN
                oldloc = 8 + n - offset
                LOCATE oldloc, 34: PRINT CHR$(26)
                LOCATE oldloc, 47: PRINT CHR$(27)
           
            END IF
        NEXT n
        showmouse
  
        DO
            keypressed$ = INKEY$
            bp = buttonpressed
            IF bp = 0 THEN letgo = 1
        LOOP UNTIL keypressed$ <> "" OR bp = 1
        '=========== handle mouse i/o
        x = mousex
        y = mousey
        IF bp = 1 THEN
            current.button = 0
            FOR n = 1 TO 6
                IF x > buttonx(n) AND x < buttonx(n) + buttonxsize(n) THEN
                    IF y > buttony(n) AND y < buttony(n) + buttonysize(n) THEN
                        current.button = n
                    END IF
                END IF
            NEXT n
            IF current.button = 0 THEN
                IF y >= 7 * ytextsize AND y < 18 * ytextsize THEN
                    n = INT(y / ytextsize) - 7
                END IF
                a = n + offset
                IF a <= numopts THEN
                    current.option = a
                    IF ct! < TIMER THEN
                        ct! = TIMER + .2
                        co = current.option
                        letgo = 0
                    ELSEIF letgo = 1 AND co = current.option THEN
                        gotone = 1
                    END IF
                END IF
            END IF

        END IF
   
        '=========== handle keyboard i/o
        SELECT CASE keypressed$
            CASE CHR$(0) + "H"
                current.button = 1
            CASE CHR$(0) + "P"
                current.button = 2
            CASE CHR$(0) + "I"
                current.button = 3
            CASE CHR$(0) + "Q"
                current.button = 4
            CASE CHR$(13)
                current.button = 5
            CASE CHR$(27)
                current.button = 6
        END SELECT
  
        '==================== do what the user says
        SELECT CASE current.button
            CASE 1
                IF current.option > 1 THEN current.option = current.option - 1
            CASE 2
                IF current.option < numopts THEN current.option = current.option + 1
            CASE 3
                IF current.option > 10 THEN
                    current.option = current.option - 10
                ELSE
                    current.option = 1
                END IF
            CASE 4
                IF current.option <= numopts - 10 THEN
                    current.option = current.option + 10
                ELSE
                    current.option = numopts
                END IF
            CASE 5
                gotone = 1
            CASE 6
                quit = 1
        END SELECT
    LOOP UNTIL quit OR gotone
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
    IF gotone THEN choose = list$(current.option)
END FUNCTION

SUB close.a.menu '(menu.index)
    showmouse
    'PUT (xtextsize * menumax(old.menu.index - 1), ytextsize), background, PSET
    PUT (minmenx, minmeny), background, PSET
    showmouse
    menu.open = 0
END SUB

SUB count.icons
    f = FREEFILE
    OPEN "book.dat" FOR INPUT AS #f
    DO
        b$ = a$
        INPUT #f, a$
    LOOP UNTIL b$ = pagename$

    icons = 0
    DO
        INPUT #f, a$
        IF a$ = "[" THEN icons = icons + 1
    LOOP UNTIL a$ = "}" OR EOF(f)

    CLOSE #f
END SUB

FUNCTION current.icon
    x = mousex
    y = mousey
    c.i = 0
    FOR n = 1 TO icons
        a = x - icon(n).x
        b = y - icon(n).y
        IF a >= 0 AND a <= icon(n).xsize THEN
            IF b >= 0 AND b <= icon(n).ysize THEN
                c.i = n
                EXIT FOR
            END IF
        END IF
    NEXT n
    current.icon = c.i
END FUNCTION

FUNCTION current.menu
    FOR n = 1 TO menus
        IF mousex < menumax(n) * xtextsize THEN EXIT FOR
    NEXT n
    IF n > menus THEN n = menus
    current.menu = n
END FUNCTION

FUNCTION double.click STATIC
    lastclick = b
    b = buttonpressed
    SELECT CASE b
        CASE 0
            IF TIMER - T! < click.speed THEN got.a.0 = 1
        CASE ELSE
            IF TIMER - T! < click.speed AND got.a.0 = 1 THEN double.click = b
            T! = TIMER
            got.a.0 = 0
    END SELECT
END FUNCTION

SUB drag.icon

    DIM overlap(icons)

    '================= switch values
    FOR n = current.icon - 1 TO 1 STEP -1
        icon(n).x = icon(n).x XOR icon(n + 1).x
        icon(n + 1).x = icon(n).x XOR icon(n + 1).x
        icon(n).x = icon(n).x XOR icon(n + 1).x
      
        icon(n).y = icon(n).y XOR icon(n + 1).y
        icon(n + 1).y = icon(n).y XOR icon(n + 1).y
        icon(n).y = icon(n).y XOR icon(n + 1).y
  
        icon(n).ysize = icon(n).ysize XOR icon(n + 1).ysize
        icon(n + 1).ysize = icon(n).ysize XOR icon(n + 1).ysize
        icon(n).ysize = icon(n).ysize XOR icon(n + 1).ysize
  
        icon(n).xsize = icon(n).xsize XOR icon(n + 1).xsize
        icon(n + 1).xsize = icon(n).xsize XOR icon(n + 1).xsize
        icon(n).xsize = icon(n).xsize XOR icon(n + 1).xsize

        a$ = iconname$(n)
        iconname$(n) = iconname$(n + 1)
        iconname$(n + 1) = a$
        a$ = progname$(n)
        progname$(n) = progname$(n + 1)
        progname$(n + 1) = a$
        a$ = progpath$(n)
        progpath$(n) = progpath$(n + 1)
        progpath$(n + 1) = a$
    NEXT n
   
    x = mousex
    y = mousey

    x1 = icon(1).x
    y1 = icon(1).y
    x2 = icon(1).x + icon(1).xsize
    y2 = icon(1).y + icon(1).ysize
    xoffset = x - x1
    yoffset = y - y1
    showmouse
    draw.icon 1, 0
    PUT (x1, y1), picture
    showmouse
    doneonce = 0
    DO
        IF (oldmousex <> mousex OR oldmousey <> mousey) AND doneonce = 1 THEN
            x = mousex
            y = mousey
            oldmousex = x
            oldmousey = y
            x1 = x - xoffset
            y1 = y - yoffset
      
            '=========account for walls
            IF x1 > xscreensize - 1 - icon(1).xsize THEN
                x1 = xscreensize - 1 - icon(1).xsize
                x2 = xscreensize - 1
                xoffset = x - x1
            END IF
            IF y1 > yscreensize - 1 - icon(1).ysize THEN
                y1 = yscreensize - 1 - icon(1).ysize
                y2 = yscreensize - 1
                yoffset = y - y1
            END IF
            IF x1 < 0 THEN
                x1 = 0
                x2 = icon(1).xsize
                xoffset = x - x1
            END IF
            IF y1 < 0 THEN
                y1 = 0
                y2 = icon(1).ysize
                yoffset = y - y1
            END IF
            IF y1 < ytextsize + 2 THEN
                y1 = ytextsize + 2
                y2 = y1 + icon(1).ysize
                yoffset = y - y1
            END IF
            '=============draw the icon if moving
            showmouse
            PUT (oldx, oldy), picture2, PSET
            GET (x1, y1)-(x1 + icon(1).xsize, y1 + icon(1).ysize), picture2
            icon(1).x = x1
            icon(1).y = y1
            draw.icon 1, 2
            showmouse
        ELSEIF doneonce = 0 THEN
            doneonce = 1
            showmouse
            FOR n = 2 TO icons
                IF icons.touching(1, n) THEN
                    okay = 1
                   
                    '======== test for overlapping with moving icon
                    IF icon(n).x < icon(1).x THEN
                        ox1b = icon(1).x
                    ELSE
                        ox1b = icon(n).x
                    END IF
                    IF icon(n).y < icon(1).y THEN
                        oy1b = icon(1).y
                    ELSE
                        oy1b = icon(n).y
                    END IF
                                          
                    IF icon(n).x + icon(n).xsize > icon(1).x + icon(1).xsize THEN
                        ox2b = icon(1).x + icon(1).xsize
                    ELSE
                        ox2b = icon(n).x + icon(n).xsize
                    END IF
                    IF icon(n).y + icon(n).ysize > icon(1).y + icon(1).ysize THEN
                        oy2b = icon(1).y + icon(1).ysize
                    ELSE
                        oy2b = icon(n).y + icon(n).ysize
                    END IF
                    LINE (ox1b, oy1b)-(ox2b, oy2b), , BF: SLEEP

                    '======== test for overlapping of other icons
                    FOR m = 1 TO overlaps
                        IF icon(n).x < icon(overlap(m)).x THEN
                            ox1a = icon(overlap(m)).x
                        ELSE
                            ox1a = icon(n).x
                        END IF
                        IF icon(n).y < icon(overlap(m)).y THEN
                            oy1a = icon(overlap(m)).y
                        ELSE
                            oy1a = icon(n).y
                        END IF
                          
                        IF icon(n).x + icon(n).xsize > icon(overlap(m)).x + icon(overlap(m)).xsize THEN
                            ox2a = icon(overlap(m)).x + icon(overlap(m)).xsize
                        ELSE
                            ox2a = icon(n).x + icon(n).xsize
                        END IF
                        IF icon(n).y + icon(n).ysize > icon(overlap(m)).y + icon(overlap(m)).ysize THEN
                            oy2a = icon(overlap(m)).y + icon(overlap(m)).ysize
                        ELSE
                            oy2a = icon(n).y + icon(n).ysize
                        END IF
                    NEXT m
                    'IF ox1a < ox1b AND ox2a > ox2b THEN
                    '     okay = 0
                    'END IF
                    '
                    'IF oy1a < oy1b AND oy2a > oy2b THEN
                    '    okay = 0
                    'END IF
                        
                    IF okay = 1 THEN
                        overlaps = overlaps + 1
                        overlap(overlaps) = n
                    END IF
                END IF
            NEXT n
           
            FOR n = overlaps TO 1 STEP -1
                draw.icon overlap(n), 1
            NEXT n

            draw.icon 1, 0
            GET (x1, y1)-(x1 + icon(1).xsize, y1 + icon(1).ysize), picture2
            showmouse
            icon(1).x = x1
            icon(1).y = y1
        END IF
        oldx = x1
        oldy = y1

    LOOP UNTIL buttonpressed = 0
    showmouse
    draw.icon 1, 1
    showmouse
END SUB

SUB draw.icon (n, c)
    SELECT CASE c
        CASE 0    '-----loads
            DEF SEG = VARSEG(picture(0))
            BLOAD iconname$(n), VARPTR(picture(0))
            DEF SEG
    
        CASE 1 '----- loads and draws
            DEF SEG = VARSEG(picture(0))
            BLOAD iconname$(n), VARPTR(picture(0))
            DEF SEG
            a = icon(n).x
            b = icon(n).y
            c = icon(n).x + icon(n).xsize
            d = icon(n).y + icon(n).ysize
            PUT (a, b), picture, PSET

        CASE 2 '------ draws
            a = icon(n).x
            b = icon(n).y
            c = icon(n).x + icon(n).xsize
            d = icon(n).y + icon(n).ysize
            PUT (a, b), picture, PSET
    END SELECT
END SUB

SUB drawicons
    FOR n = icons TO 1 STEP -1
        DEF SEG = VARSEG(picture(0))
        BLOAD iconname$(n), VARPTR(picture(0))
        DEF SEG
        PUT (icon(n).x, icon(n).y), picture, PSET
    NEXT n
END SUB

SUB drawscreen
    '========================draw.menus
    showmouse
    CLS
    n = 1
    menumax(0) = 1
    FOR a = 1 TO menus
        IF a = 1 THEN shift = 0
        n = n + LEN(menu$(a, 0)) + 4
        menumax(a) = n
        LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
        LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
    NEXT a
  
    LOCATE 1, 60 - INT(LEN(pagename$) / 2)
    PRINT pagename$
   
    '========= draw the flip buttons
    DEF SEG = VARSEG(button(0))
    BLOAD "flipl.pic", VARPTR(button(0))
    PUT (flipx, flipy), button, PSET
    flipxsize = button(0)
    flipysize = button(1)
    DEF SEG = VARSEG(button(0))
    BLOAD "flipr.pic", VARPTR(button(0))
    flipx2 = flipx + flipxsize + 5
    PUT (flipx2, flipy), button, PSET

    maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
    LINE (0, ytextsize)-(640, ytextsize)
    LINE (0, ytextsize - 2)-(maximum.menux, ytextsize - 2)
   
    showmouse
END SUB

FUNCTION exists (name$)
    SHELL ("dir/b/o " + name$ + " > junk")
    f = FREEFILE
    OPEN "junk" FOR INPUT AS #f
    ok = 0
    IF NOT EOF(f) THEN ok = 1
    CLOSE #f
    exists = ok
END FUNCTION

SUB flip.page (direction)
    np = current.page + direction
    IF np >= 1 AND np <= numpages THEN
        current.page = np
        pagechanged = 1
    END IF
END SUB

SUB handle.icon (c.i)
    f = FREEFILE
   
    SHELL "path > junk"
    OPEN "junk" FOR INPUT AS #f
    INPUT #f, oldpath$
    CLOSE #f
   
    SHELL "cd > junk"
    OPEN "junk" FOR INPUT AS #f
    INPUT #f, c.d$
    CLOSE #f
    OPEN "execute.bat" FOR OUTPUT AS #f
    PRINT #f, "@echo off"
    'PRINT #f, "path "; progpath$(c.i)
    PRINT #f, "cd "; progpath$(c.i)
   
    a$ = RIGHT$(progname$(c.i), 3)
    IF LCASE$(a$) = "bat" THEN
        PRINT #f, "call " + progname$(c.i)
    ELSE
        yup = 0
        FOR n = 1 TO LEN(progname$(c.i))
            IF MID$(progname$(c.i), n, 1) = "." THEN yup = 1
        NEXT n
        IF yup = 1 THEN
            PRINT #f, progname$(c.i)
        ELSE
            c$ = "dir/b " + progpath$(c.i) + "\" + progname$(c.i) + ".* > junk"
            SHELL c$
            g = FREEFILE
            OPEN "junk" FOR INPUT AS #g
            IF NOT EOF(g) THEN
                INPUT #g, a$
            ELSE
                a$ = ""
            END IF
            CLOSE #g
            IF LCASE$(RIGHT$(a$, 3)) = "bat" THEN
                PRINT #f, "call " + progname$(c.i)
            ELSE
                PRINT #f, progname$(c.i)
            END IF
        END IF
    END IF
    'PRINT #f, oldpath$
    PRINT #f, "cd "; c.d$
    PRINT #f, "gui.bat"
    CLOSE #f
    done = 1
END SUB

SUB handle.option (option$)
    SELECT CASE option$
        CASE "Exit"
            close.a.menu
            n = FREEFILE
            OPEN "junk" FOR OUTPUT AS #n
            PRINT #n, "Yes.pic"
            PRINT #n, "no.pic"
            CLOSE #n
            IF choice("junk", 2, "Are you sure you want to exit?") = 1 THEN
                OPEN "execute.bat" FOR OUTPUT AS #n
                PRINT #n, "@echo Have a Nice Day!"
                CLOSE #n
                done = 1
            END IF
        CASE "DOS Shell"
            close.a.menu
            showmouse
            SCREEN 0
            SHELL
            SCREEN 12
            showmouse
            PALETTE 0, 63 + 63 * 256 + 63 * 65536
            PALETTE 15, 0
            drawscreen
            drawicons
        CASE "Add a Page"
            close.a.menu
            add.a.page
        CASE "Turn to Page..."
            close.a.menu
            savepage
            turn.to.page
        CASE "Remove a Page"
            close.a.menu
            remove.a.page
        CASE "Insert a Page"
            close.a.menu
            insert.a.page
        CASE "Retitle this Page"
            close.a.menu
            retitle.this.page
        CASE "Add an Icon"
            close.a.menu
            add.an.icon
        CASE "Remove an Icon"
            close.a.menu
            remove.an.icon
        CASE "Alter an Icon's Properties"
            close.a.menu
            alter.icon.properties
        CASE "Run..."
            close.a.menu
            browse
    END SELECT
END SUB

FUNCTION icons.touching (n, m)
    a = icon(m).x
    b = icon(m).y
    c = a + icon(m).xsize
    d = b + icon(m).ysize

    x1 = icon(n).x
    y1 = icon(n).y
    x2 = x1 + icon(n).xsize
    y2 = y1 + icon(n).ysize

    c1 = (a >= x1 AND a <= x2)
    c2 = (c >= x1 AND c <= x2)
    c3 = (b >= y1 AND b <= y2)
    c4 = (d >= y1 AND d <= y2)
    c5 = (a <= x1 AND c >= x2)
    c6 = (b <= y1 AND d >= y2)

    IF (c1 OR c2 OR c5) AND (c3 OR c4 OR c6) THEN icons.touching = 1
END FUNCTION

SUB insert.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            DO
                INPUT #f, a$
                IF a$ = pagename$ THEN
                    PRINT #g, pn$
                    PRINT #g, "{"
                    PRINT #g, "}"
                END IF
                PRINT #g, a$
            LOOP UNTIL EOF(f)
            numpages = numpages + 1
            icons = 0
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            pagename$ = pn$
            drawscreen
        END IF
    END IF
END SUB

SUB load.icons
    f = FREEFILE
    OPEN "book.dat" FOR INPUT AS #f
    a$ = ""
    WHILE b$ <> pagename$
        b$ = a$
        INPUT #f, a$
    WEND

    n = 0: a$ = ""
    WHILE n < icons
        b$ = a$
        INPUT #f, a$
        IF a$ = "[" THEN
            n = n + 1
            iconname$(n) = b$
           
            DEF SEG = VARSEG(picture(0))
            BLOAD iconname$(n), VARPTR(picture(0))
            DEF SEG
            icon(n).xsize = picture(0)
            icon(n).ysize = picture(1)

            INPUT #f, icon(n).x
            INPUT #f, icon(n).y
            INPUT #f, a$
            IF a$ <> "]" THEN
                progname$(n) = a$
                INPUT #f, a$
                IF a$ <> "]" THEN
                    progpath$(n) = a$
                END IF
            END IF
            WHILE a$ <> "]"
                INPUT #f, a$
            WEND
        END IF
    WEND
    CLOSE #f
END SUB

SUB load.menus (filenum)
    FOR n = 1 TO menus
        INPUT #filenum, menu$(n, 0)
        INPUT #filenum, menulength(n)
        maximum.menux = maximum.menux + LEN(menu$(n, 0))
        FOR a = 1 TO menulength(n)
            INPUT #filenum, menu$(n, a)
        NEXT a
    NEXT n
    maximum.menux = maximum.menux * xtextsize
END SUB

SUB load.page
    f = FREEFILE
    IF exists("book.dat") THEN
        '============== find the current.page
        OPEN "book.dat" FOR INPUT AS #f
        fini = 0: pagesfound = 0
        WHILE NOT (EOF(f) OR fini = 1)
            b$ = a$
            INPUT #f, a$
            IF a$ = "{" THEN pagesfound = pagesfound + 1
            IF pagesfound = current.page THEN
                '================== find data on current page
                fini = 1
                pagename$ = b$

            END IF
        WEND
        CLOSE #f
    ELSE
        OPEN "book.dat" FOR OUTPUT AS #f
        PRINT #f, "GuiJe"
        PRINT #f, "{"
        PRINT #f, "}"
        CLOSE #f
        '====================== Create data for title page
        pagename$ = "GuiJe"
        numpages = 1
    END IF
END SUB

SUB message (filename$, iconname$)
    DIM background2(15000), background3(15000), background4(15000)
    '============= check the length & maxwidth of the file
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    maxwidth = 0
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        IF LEN(a$) > maxwidth THEN maxwidth = LEN(a$)
        numlines = numlines + 1
    WEND
    CLOSE #f
    '==================================set values, draw window
    '----- load the icon data
    DEF SEG = VARSEG(button(0))
    BLOAD iconname$, VARPTR(button(0))
    buttonxsize = button(0)
    buttonysize = button(1)
   
    '==================================set values, draw window

    '---- determine the necessary size of the window
    '--x
    textx = 40 - INT(maxwidth / 2)
    xminsize = (maxwidth + 3) * xtextsize
 
    '--y
    yminsize = numlines * ytextsize + buttonysize + 20

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    mx = x1 + (x2 - x1) / 2
    my = y1 + (y2 - y1) / 2
    GET (x1, y1)-(mx, my), background
    GET (mx + 1, y1)-(x2, my), background2
    GET (x1, my + 1)-(mx, y2), background3
    GET (mx + 1, my + 1)-(x2, y2), background4
    LINE (x1, y1)-(x2, y2), 0, BF

    OPEN filename$ FOR INPUT AS #f
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        LOCATE texty + lnum, textx + (maxwidth - LEN(a$)) / 2
        lnum = lnum + 1
        PRINT a$
    WEND
    CLOSE #f
    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon position
    buttonx = 320 - button(0) / 2
    buttony = y2 - (button(1) + 5)

    '------- draw the icon
    PUT (buttonx, buttony), button
   
    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            IF x >= buttonx AND x <= buttonx + buttonxsize THEN
                IF y >= buttony AND y <= buttony + buttonysize THEN
                    gotone = 1
                END IF
            END IF
        END IF
        IF INKEY$ <> "" THEN gotone = 1
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    PUT (mx + 1, y1), background2, PSET
    PUT (x1, my + 1), background3, PSET
    PUT (mx + 1, my + 1), background4, PSET
    showmouse
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

FUNCTION on.a.menu
    q = 0
    IF mousex > minmenx AND mousex < maxmenx THEN
        IF mousey > minmeny AND mousey < maxmeny THEN
             q = 1
        END IF
    END IF
    on.a.menu = q
END FUNCTION

SUB open.a.menu (menu.index)

    '--------- determine width
    menuwidth = 0
    FOR n = 1 TO menulength(menu.index)
        cwidth = LEN(menu$(menu.index, n))
        IF cwidth > menuwidth THEN menuwidth = cwidth
    NEXT n

    '--------- get screen
    minmenx = xtextsize * menumax(menu.index - 1) - xtextsize
    minmeny = ytextsize - ytextsize / 4
    maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + xtextsize
    maxmeny = menulength(menu.index) * ytextsize + minmeny + ytextsize / 2
    GET (minmenx, minmeny)-(maxmenx, maxmeny), background
    PUT (minmenx, minmeny), background
    old.menu.index = menu.index

    '--------- print text
    FOR n = 1 TO menulength(menu.index)
        LOCATE 1 + n, menumax(menu.index - 1) + 1
        PRINT menu$(menu.index, n)
    NEXT n

    '--------- separate text with dotted line
    FOR n = 2 TO menulength(menu.index)
        LINE (minmenx, n * ytextsize)-(maxmenx, n * ytextsize), 8, , 21845
    NEXT n

    '--------- draw edge of menu
    LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
    LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
    LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1), 7
    LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1), 7
    LINE (minmenx + 1, maxmeny - 1)-(maxmenx - 1, maxmeny - 1), 8
    LINE (maxmenx - 1, maxmeny - 1)-(maxmenx - 1, minmeny + 1), 8
    PSET (minmenx, minmeny), 0
    PSET (minmenx, maxmeny), 0
    PSET (maxmenx, minmeny), 0
    PSET (maxmenx, maxmeny), 0
    PSET (minmenx + 1, minmeny + 1)
    PSET (minmenx + 1, maxmeny - 1)
    PSET (maxmenx - 1, minmeny + 1)
    PSET (maxmenx - 1, maxmeny - 1)

END SUB

FUNCTION read.menu$
    y = mousey
    selection = 0
    FOR n = 1 TO menulength(old.menu.index)
        IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
            selection = n
        END IF
    NEXT n
    read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB remove.a.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        b$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(b$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    pn$ = choose$("junk")

    '============= confirm removal of page
    OPEN "junk" FOR OUTPUT AS #f
    PRINT #f, "okay.pic"
    PRINT #f, "cancel.pic"
    CLOSE #f
    IF choice("junk", 2, "All data for this page will be removed.") = 1 THEN
        '============== remove the page
        OPEN "book.dat" FOR INPUT AS #f
        OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF LEFT$(a$, 12) <> pn$ THEN
                PRINT #g, a$
            ELSE
                DO
                    INPUT #f, a$
                LOOP UNTIL a$ = "}"
            END IF
        WEND
        CLOSE g, f
        KILL "book.dat"
        SHELL "rename junk book.dat"
        numpages = numpages - 1
       
        IF pn$ = pagename$ THEN
            current.page = 1
            page.changed = 1
            icons.changed = 1
        END IF
    END IF
END SUB

SUB remove.an.icon
    f = FREEFILE
    OPEN "junk" FOR OUTPUT AS #f
    FOR n = 1 TO icons
        PRINT #f, iconname$(n)
    NEXT n
    CLOSE #f
    r$ = choose$("junk")
    IF r$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "Are you sure?") = 1 THEN
            savepage
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            yup = 0
            WHILE NOT EOF(f)
                INPUT #f, a$
                IF a$ = r$ AND yup = 0 THEN
                    yup = 1
                    DO
                        INPUT #f, a$
                    LOOP UNTIL a$ = "]"
                ELSE
                    PRINT #g, a$
                END IF
            WEND
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            icons.changed = 1
        END IF
    END IF
END SUB

SUB retitle.this.page
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
        g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF a$ = pagename$ THEN
                PRINT #g, pn$
            ELSE
                PRINT #g, a$
            END IF
        WEND
        pagename$ = pn$
        CLOSE f, g
        KILL "book.dat"
        SHELL "rename junk book.dat"
        drawscreen
        drawicons
    END IF
END SUB

SUB savepage
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        INPUT #f, a$
        PRINT #g, a$
        IF a$ = pagename$ THEN
            DO
                INPUT #f, a$
            LOOP UNTIL a$ = "}"
            PRINT #g, "{"
            FOR n = 1 TO icons
                PRINT #g, iconname$(n)
                PRINT #g, "["
                PRINT #g, icon(n).x
                PRINT #g, icon(n).y
                PRINT #g, progname$(n)
                PRINT #g, progpath$(n)
                PRINT #g, "]"
            NEXT n
            PRINT #g, "}"
        END IF
    WEND
    CLOSE f, g
    KILL "book.dat"
    SHELL "rename junk book.dat"
END SUB

SUB showmouse STATIC
    IF mouseon THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
    mouseon = 1 - mouseon
END SUB

FUNCTION taketext$ (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    b = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = b + 2 * ytextsize
    LINE (a, b)-(c, d), , B
    LINE (a + 2, b + 2)-(c - 2, d - 2), , B
    LINE (a + 1, b + 1)-(a + 1, d - 1)
    LINE (a + 1, b + 1)-(c - 1, b + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 31
                IF n < 127 THEN
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = b$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        showmouse
        LINE (a, b)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
         
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, offset + 1, maxlength)
            END IF
            PRINT display.text$
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        b = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, b)-(a, d)
        ELSE
            LINE (a, b)-(c, d), , B
        END IF
        showmouse
    LOOP UNTIL ready OR cancel
    IF ready THEN taketext$ = text$
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue! (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    b = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = b + 2 * ytextsize
    LINE (a, b)-(c, d), , B
    LINE (a + 2, b + 2)-(c - 2, d - 2), , B
    LINE (a + 1, b + 1)-(a + 1, d - 1)
    LINE (a + 1, b + 1)-(c - 1, b + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE ELSE
                IF ((n = 45) OR (n = 46) OR ((n < 58) AND (n > 47))) AND LEN(text$) < maxlength THEN '--(text)
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = b$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        LINE (a, b)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
            showmouse
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, shift, maxlength)
            END IF
            PRINT display.text$

            'IF LEN(text$) <= maxlength THEN
            '    PRINT text$;
            'ELSE
            '    PRINT LEFT$(text$, maxlength);
            'END IF
            showmouse
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        b = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, b)-(a, d)
        ELSE
            LINE (a, b)-(c, d), , B
        END IF
    LOOP UNTIL ready OR cancel
    IF ready THEN takevalue! = VAL(text$)
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

SUB turn.to.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        b$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(b$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    a$ = choose$("junk")
   
    IF a$ <> "" THEN
        pagename$ = a$
        '============= get the page number
        OPEN "junk" FOR INPUT AS #f
        current.page = 0
        DO
            INPUT #f, a$
            current.page = current.page + 1
        LOOP UNTIL a$ = pagename$
        CLOSE #f
        pagechanged = 1
        icons.changed = 1
        'drawscreen
    END IF
END SUB

