DEFINT A-Z

'=============== declarations of subs / functions
DECLARE SUB savepage ()
DECLARE SUB showmouse (mouseon%)
DECLARE SUB drawbox (n%, do.title%)
DECLARE SUB drawtext (x%, y%, text$, maxx%)
DECLARE SUB flip.page (direction%)
DECLARE SUB rename.a.box ()
DECLARE SUB remove.a.box ()
DECLARE SUB create.a.box ()
DECLARE SUB expand.box (n%)
DECLARE SUB drag.a.box (n%)
DECLARE SUB resize.a.box (boxnum%)
DECLARE SUB open.box (n%)
DECLARE FUNCTION double.click% ()
DECLARE FUNCTION boxes.icons.touching% (n%, m%)
DECLARE SUB drag.closed.box (n%, x%, y%)
DECLARE SUB close.a.box (current.box%)
DECLARE FUNCTION on.closed.box% (mx%, my%)
DECLARE SUB draw.box.icon (n%, c%)
DECLARE SUB handle.buttonpress.on.box (current.box%, mx%, my%)
DECLARE FUNCTION button.pressed.on.box% (n%, mx%, my%)
DECLARE FUNCTION on.open.box% (x%, y%)
DECLARE SUB draw.boxes ()
DECLARE SUB load.boxes ()
DECLARE SUB retitle.this.page ()
DECLARE SUB insert.a.page ()
DECLARE SUB remove.a.page ()
DECLARE SUB turn.to.page ()
DECLARE SUB add.a.page ()
DECLARE SUB load.page ()
DECLARE FUNCTION exists% (name$)
DECLARE FUNCTION choose$ (list$)
DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE SUB drawscreen ()
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION takevalue! (text$)
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE SUB handle.option (option$)
DECLARE SUB close.a.menu ()
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB load.menus (filenum%)
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()

'======================= variables / types / constants
TYPE boxtype
    onoff AS INTEGER
    iconx AS INTEGER
    icony AS INTEGER
    iconxsize AS INTEGER
    iconysize AS INTEGER
    x AS INTEGER
    y AS INTEGER
    xsize AS INTEGER
    ysize AS INTEGER
    scrollx AS INTEGER
    scrolly AS INTEGER
END TYPE

TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE

'----------- constants
CONST click.speed = .15
CONST xscreensize = 639, yscreensize = 479
CONST xtextsize = 8, ytextsize = 16
CONST zerox = 320, zeroy = 240
CONST xboxbordersize = 20, yboxbordersize = 18
CONST xboxbuttonsize = 14, yboxbuttonsize = 14
CONST xminboxsize = 6 * 20, yminboxsize = 7 * 18
CONST default.box.onoff = 0
CONST default.boxicon.x = 50, default.boxicon.y = 50
CONST default.box.x = 70, default.box.y = 70
CONST default.box.xsize = 250, default.box.ysize = 250
CONST flipx = 291, flipy = 0
DIM SHARED flipx2, flipxsize, flipysize
'----------- global variables
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(15000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED rusure(5000), menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED picture2(2633), picture(2633), numpics, button(2633)
DIM SHARED current.page, pagename$, numboxes, pagechanged, numpages
REDIM SHARED box(0) AS boxtype, boxicon$(0), boxname$(0)
'================= load data
'------------load menus
OPEN "gui.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 6), menumax(menus), menulength(menus)
xrange = 10
yrange = 10
load.menus (1)
CLOSE #1

'------------load page
IF exists("cpg.~~") THEN
    OPEN "cpg.~~" FOR INPUT AS #1
    INPUT #1, current.page
    CLOSE #1
   
    '------- count pages
    OPEN "book.dat" FOR INPUT AS #1
    WHILE NOT EOF(1)
        INPUT #1, a$
        IF a$ = "{" THEN numpages = numpages + 1
    WEND
    CLOSE #1
ELSE
    current.page = 1
    SHELL ("echo 1 > cpg.~~")
END IF
load.page '<--< (also counts the boxes on the page)
REDIM SHARED box(numboxes) AS boxtype, boxicon$(numboxes), boxname$(numboxes)
load.boxes

'=================================interrupts
'ON ERROR GOTO errhandle

'=========================Misc.
'------------set up graphics
SCREEN 12: CLS
PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0

'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
showmouse (1)
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)

'------------draw the screen
drawscreen
draw.boxes
'===============================main program==================================
DO
   
    dc = double.click
    IF pagechanged = 1 THEN
        pagechanged = 0
        load.page
        REDIM SHARED box(numboxes) AS boxtype, boxicon$(numboxes), boxname$(numboxes)
        drawscreen
        load.boxes
        draw.boxes
    END IF
    '======================== mouse button pressed
    bp = buttonpressed
    mx = mousex
    my = mousey
    IF bp THEN
        IF my <= 15 THEN
            IF mx <= maximum.menux THEN
                '------- left button on the upper menus
                IF menu.open <> 0 THEN
                    close.a.menu
                END IF
                IF menu.open <> current.menu THEN
                    menu.open = current.menu
                    showmouse (0)
                    open.a.menu (current.menu)
                    showmouse (1)
                END IF
                DO: LOOP UNTIL buttonpressed = 0
            ELSE

                IF menu.open <> 0 THEN close.a.menu
                '--- page flipping buttons
                IF my >= flipy AND my <= flipy + flipysize THEN
                    IF mx >= flipx AND mx <= flipx + flipxsize THEN
                        flip.page (-1)
                    ELSEIF mx >= flipx2 AND mx <= flipx2 + flipxsize THEN
                        flip.page (1)
                    END IF
                END IF
            END IF
        ELSEIF on.a.menu AND menu.open <> 0 THEN
            handle.option (read.menu$)'----read.menu$ is a function
        ELSE
            '------- button pressed off the menus
            IF menu.open <> 0 THEN
                close.a.menu
                DO: LOOP UNTIL buttonpressed = 0
            ELSE ' (all menus are closed)
                a = on.open.box(mx, my)
                IF a THEN
                    handle.buttonpress.on.box a, mx, my
                ELSE
                    a = on.closed.box(mx, my)
                    IF a THEN
                        'IF bp = 2 THEN
                        '    drag.closed.box a, mx, my
                        'ELSEIF bp = 1 THEN
                        '    IF dc THEN
                        '        open.box (a)
                        '    END IF
                        'END IF
                        IF dc THEN
                            open.box (a)
                        ELSEIF bp = 2 THEN
                            drag.closed.box a, mx, my
                        END IF

                    END IF
                END IF
            END IF
        END IF
    END IF
LOOP UNTIL done
CLOSE
END
'===============================subroutines===================================
errhandle:
    RESUME NEXT

SUB add.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR APPEND AS #f
            PRINT #f, pn$
            PRINT #f, "{"
            PRINT #f, "}"
            CLOSE #f
            numpages = numpages + 1
        END IF
    END IF
END SUB

FUNCTION boxes.icons.touching (n, m)
    a = box(m).iconx
    b = box(m).icony
    c = a + box(m).iconxsize
    d = b + box(m).iconysize

    x1 = box(n).iconx
    y1 = box(n).icony
    x2 = a + box(n).iconxsize
    y2 = b + box(n).iconysize

    c1 = (a >= x1 AND a <= x2)
    c2 = (c >= x1 AND c <= x2)
    c3 = (b >= y1 AND b <= y2)
    c4 = (d >= y1 AND d <= y2)
    c5 = (a <= x1 AND c >= x2)
    c6 = (b <= y1 AND d >= y2)

    IF (c1 OR c2 OR c5) AND (c3 OR c4 OR c6) THEN boxes.icons.touching = 1
END FUNCTION

FUNCTION button.pressed.on.box (n, mx, my)
    x1 = box(n).x
    y1 = box(n).y
    x2 = box(n).x + box(n).xsize
    y2 = box(n).y + box(n).ysize
   
    'close
    a = x1 + xboxbordersize / 2 - xboxbuttonsize / 2
    b = y1 + yboxbordersize / 2 - yboxbuttonsize / 2
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 1

    'open
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = y1 + yboxbordersize / 2 - yboxbuttonsize / 2
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 2

    'resize
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = y2 - yboxbordersize / 2 - yboxbuttonsize / 2
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 3
   
    'up
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = (y1 + y2) / 2 - yboxbordersize * 2
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 4
   
    'down
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = (y1 + y2) / 2 - yboxbordersize
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 5
   
    'left
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = (y1 + y2) / 2
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 6

   
    'right
    a = x2 - xboxbordersize / 2 - xboxbuttonsize / 2
    b = (y1 + y2) / 2 + yboxbordersize
    c = a + xboxbuttonsize
    d = b + yboxbuttonsize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 7

    'title
    a = x1 + xboxbordersize
    b = y1
    c = x2 - xboxbordersize
    d = y2 + yboxbordersize
    IF a <= mx AND mx <= c AND b <= my AND my <= d THEN button.pressed.on.box = 8

END FUNCTION

FUNCTION buttonpressed%
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

FUNCTION choice (filename$, icons, text$)
    '==================================set values, draw window
    DIM file$(icons), buttonxsize(icons), buttonysize(icons)
    DIM buttonx(icons), buttony(icons)
    '----- load the icon data
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    n = 0
    DEF SEG = VARSEG(button(0))
    FOR n = 1 TO icons
        INPUT #f, file$(n)
        BLOAD file$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
    NEXT n
    CLOSE #f

    '---- determine the necessary size of the window
    '--x
    tlen = LEN(text$)
    textx = 40 - INT(tlen / 2)
    FOR n = 1 TO icons
        xminsize = xminsize + buttonxsize(n) + 10
    NEXT n
    IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize
  
    '--y
    FOR n = 1 TO icons
        IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
    NEXT n
    yminsize = yminsize + 40

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse (0)

    '------- get background and print text
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE texty, textx: PRINT text$;

    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon positions

    '-- x
    a = xminsize
    FOR n = 1 TO icons
        a = a - buttonxsize(n)
    NEXT n
    a = a / (icons + 1)
    icx = 320 - (xminsize / 2)
    FOR n = 1 TO icons
        icx = icx + a
        buttonx(n) = icx
        icx = icx + buttonxsize(n)
    NEXT n

    '-- y
    a = y2 - (y1 + 2 * ytextsize)
    a = y2 - a / 2
    FOR n = 1 TO icons
        buttony(n) = a - buttonysize(n) / 2
    NEXT n
                          
    '----- load and draw the icons
    FOR n = 1 TO icons
        DEF SEG = VARSEG(button(0))
        BLOAD file$(n), VARPTR(button(0))
        PUT (buttonx(n), buttony(n)), button
    NEXT n
    DEF SEG

    showmouse (1)
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            FOR n = 1 TO icons
                IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
                    IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
                        choice = n
                        gotone = n
                    END IF
                END IF
            NEXT n
        END IF
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse (0)
    PUT (x1, y1), background, PSET
    showmouse (1)
END FUNCTION

FUNCTION choose$ (list$)
    l = FREEFILE

    '---------- check for listsize
    OPEN list$ FOR INPUT AS #l
    DO
        LINE INPUT #l, junk$
        numopts = numopts + 1
    LOOP UNTIL EOF(l)
    CLOSE #l

    DIM list$(numopts)

    '---------- load the list
    OPEN list$ FOR INPUT AS #l
    FOR n = 1 TO numopts
        LINE INPUT #l, list$(n)
    NEXT n
    CLOSE #l


    DIM buttonx(6), buttony(6), buttonxsize(6), buttonysize(6), buttonname$(6)

    '-----draw background
    x1 = 31 * xtextsize
    x2 = 49 * xtextsize
    y1 = 5 * ytextsize
    y2 = 20 * ytextsize
    showmouse (0)
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 3, y1 + 3)-(x2 - 3, y2 - 3), , B
    LINE (x1 + 1 * xtextsize, y1 + 3.5 * xtextsize)-(x2 - 1 * xtextsize, y2 - 2.5 * ytextsize), , B
    '-----names
    buttonname$(1) = "up.pic"
    buttonname$(2) = "down.pic"
    buttonname$(3) = "pgup.pic"
    buttonname$(4) = "pgdown.pic"
    buttonname$(5) = "okay.pic"
    buttonname$(6) = "cancel.pic"
    '-----locations
    buttonx(1) = 292: buttony(1) = 87
    buttonx(2) = 326: buttony(2) = 87
    buttonx(3) = 265: buttony(3) = 87
    buttonx(4) = 353: buttony(4) = 87
    buttonx(5) = 263: buttony(5) = 289
    buttonx(6) = 323: buttony(6) = 289

    f = FREEFILE
    FOR n = 1 TO 6
        DEF SEG = VARSEG(button(0))
        BLOAD buttonname$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
        DEF SEG
        PUT (buttonx(n), buttony(n)), button, PSET
    NEXT n

    showmouse (1)
    offset = 1
    current.option = 1
    DO
        IF doneonce THEN
            LOCATE oldloc, 34: PRINT " "
            LOCATE oldloc, 47: PRINT " "
        ELSE
            doneonce = 1
        END IF
        '=========== draw the text on the menu
        IF current.option > offset + 9 THEN offset = current.option - 9
        IF current.option < offset THEN offset = current.option
        IF numopts > 9 THEN
            q = 9
        ELSE
            q = numopts - 1
        END IF
        showmouse (0)
        FOR n = offset TO offset + q
            LOCATE 8 + n - offset, 35
            PRINT list$(n);
            FOR m = LEN(list$(n)) TO 12
                PRINT " ";
            NEXT m
            IF n = current.option THEN
                oldloc = 8 + n - offset
                LOCATE oldloc, 34: PRINT CHR$(26)
                LOCATE oldloc, 47: PRINT CHR$(27)
           
            END IF
        NEXT n
        showmouse (1)
  
        DO
            keypressed$ = INKEY$
            bp = buttonpressed
            IF bp = 0 THEN letgo = 1
        LOOP UNTIL keypressed$ <> "" OR bp = 1
        '=========== handle mouse i/o
        x = mousex
        y = mousey
        IF bp = 1 THEN
            current.button = 0
            FOR n = 1 TO 6
                IF x > buttonx(n) AND x < buttonx(n) + buttonxsize(n) THEN
                    IF y > buttony(n) AND y < buttony(n) + buttonysize(n) THEN
                        current.button = n
                    END IF
                END IF
            NEXT n
            IF current.button = 0 THEN
                IF y >= 7 * ytextsize AND y < 18 * ytextsize THEN
                    n = INT(y / ytextsize) - 7
                END IF
                a = n + offset
                IF a <= numopts THEN
                    current.option = a
                    IF ct! < TIMER THEN
                        ct! = TIMER + .2
                        co = current.option
                        letgo = 0
                    ELSEIF letgo = 1 AND co = current.option THEN
                        gotone = 1
                    END IF
                END IF
            END IF

        END IF
   
        '=========== handle keyboard i/o
        SELECT CASE keypressed$
            CASE CHR$(0) + "H"
                current.button = 1
            CASE CHR$(0) + "P"
                current.button = 2
            CASE CHR$(0) + "I"
                current.button = 3
            CASE CHR$(0) + "Q"
                current.button = 4
            CASE CHR$(13)
                current.button = 5
            CASE CHR$(27)
                current.button = 6
        END SELECT
  
        '==================== do what the user says
        SELECT CASE current.button
            CASE 1
                IF current.option > 1 THEN current.option = current.option - 1
            CASE 2
                IF current.option < numopts THEN current.option = current.option + 1
            CASE 3
                IF current.option > 10 THEN
                    current.option = current.option - 10
                ELSE
                    current.option = 1
                END IF
            CASE 4
                IF current.option <= numopts - 10 THEN
                    current.option = current.option + 10
                ELSE
                    current.option = numopts
                END IF
            CASE 5
                gotone = 1
            CASE 6
                quit = 1
        END SELECT
    LOOP UNTIL quit OR gotone
    showmouse (0)
    PUT (x1, y1), background, PSET
    showmouse (1)
    IF gotone THEN choose = list$(current.option)
END FUNCTION

SUB close.a.box (n)
    box(n).onoff = 0
   
    showmouse (0)
    '==================== erase the box
    x1 = box(n).x
    y1 = box(n).y
    x2 = box(n).x + box(n).xsize
    y2 = box(n).y + box(n).ysize
    LINE (x1, y1)-(x2, y2), 0, BF
   
    '=================== draw the icon
    'DEF SEG = VARSEG(picture(0))
    'BLOAD boxicon$(n), VARPTR(picture(0))
    'PUT (box(n).iconx, box(n).icony), picture, PSET
    draw.boxes
    showmouse (1)
END SUB

SUB close.a.menu '(menu.index)
    showmouse (0)
    PUT (minmenx, minmeny), background, PSET
    showmouse (1)
    menu.open = 0
END SUB

SUB create.a.box
    DO
        continue = 1
        bn$ = taketext$("What title do you wish to give this box?")
        FOR n = 1 TO LEN(bn$)
            SELECT CASE MID$(bn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The box title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1
   
    IF bn$ <> "" THEN
        SHELL "echo okay.pic > junk"
        v = choice("junk", 1, "Please choose an icon to represent this box.")
        SHELL "dir/o/b *.pic > junk"
        picname$ = choose$("junk")
            IF picname$ <> "" THEN
            f = FREEFILE
            OPEN "junk" FOR OUTPUT AS #f
            PRINT #f, "yes.pic"
            PRINT #f, "no.pic"
            CLOSE #f
            IF choice("junk", 2, "Are you sure?") = 1 THEN
                OPEN "book.dat" FOR INPUT AS #f
                g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
                b$ = ""
                WHILE NOT EOF(f)
                    b$ = a$
                    INPUT #f, a$
                    PRINT #g, a$
                    IF b$ = pagename$ THEN
                        PRINT #g, bn$
                        PRINT #g, "["
                        PRINT #g, default.box.onoff
                        PRINT #g, picname$
                        PRINT #g, default.boxicon.x
                        PRINT #g, default.boxicon.y
                        PRINT #g, default.box.x
                        PRINT #g, default.box.y
                        PRINT #g, default.box.xsize
                        PRINT #g, default.box.ysize
                        PRINT #g, 0
                        PRINT #g, 0
                        PRINT #g, "]"
                    END IF
                WEND
                CLOSE f, g
                KILL "book.dat"
                SHELL "rename junk book.dat"
                numboxes = numboxes + 1
                pagechanged = 1
            END IF
        END IF
    END IF
END SUB

FUNCTION current.menu
    FOR n = 1 TO menus
        IF mousex < menumax(n) * xtextsize THEN EXIT FOR
    NEXT n
    IF n > menus THEN n = menus
    current.menu = n
END FUNCTION

FUNCTION double.click STATIC
    lastclick = b
    b = buttonpressed
    SELECT CASE b
        CASE 0
            IF TIMER - t! < click.speed THEN got.a.0 = 1
        CASE ELSE
            IF TIMER - t! < click.speed AND got.a.0 = 1 THEN double.click = b
            t! = TIMER
            got.a.0 = 0
    END SELECT
END FUNCTION

SUB drag.a.box (n)
    mx = mousex
    my = mousey
    xoffset = mx - box(n).x
    yoffset = my - box(n).y
    WHILE buttonpressed <> 0
        oldx = mx
        oldy = my
        mx = mousex
        my = mousey
        xokay = 1
        yokay = 1
        IF (mx <= xoffset) OR (639 - mx <= box(n).xsize - xoffset) THEN xokay = 0
        IF (my <= yoffset + ytextsize + 1) OR (479 - my <= box(n).ysize - yoffset) THEN yokay = 0
        IF xokay = 1 AND yokay = 1 THEN
            IF mx <> oldx OR my <> oldy THEN
                a = box(n).x
                b = box(n).y
                c = a + box(n).xsize
                d = b + box(n).ysize
                showmouse (0)
                LINE (a, b)-(c, d), 0, BF
                showmouse (1)
                box(n).x = mx - xoffset
                box(n).y = my - yoffset
                drawbox n, 0
                xoffset = mx - box(n).x
                yoffset = my - box(n).y
            END IF
        ELSEIF xokay = 1 AND yokay = 0 THEN
            IF mx <> oldx THEN
                a = box(n).x
                b = box(n).y
                c = a + box(n).xsize
                d = b + box(n).ysize
                showmouse (0)
                LINE (a, b)-(c, d), 0, BF
                showmouse (1)
                box(n).x = mx - xoffset
                drawbox n, 0
                xoffset = mx - box(n).x
            END IF
        ELSEIF yokay = 1 AND xokay = 0 THEN
            IF my <> oldy THEN
                a = box(n).x
                b = box(n).y
                c = a + box(n).xsize
                d = b + box(n).ysize
                showmouse (0)
                LINE (a, b)-(c, d), 0, BF
                showmouse (1)
                box(n).y = my - yoffset
                drawbox n, 0
                yoffset = my - box(n).y
            END IF
        ELSEIF xokay = 0 AND yokay = 0 THEN
            xoffset = mx - box(n).x
            yoffset = my - box(n).y
        END IF
    WEND
    draw.boxes
END SUB

SUB drag.closed.box (n, x, y)
 
    x1 = box(n).iconx
    y1 = box(n).icony
    x2 = x1 + box(n).iconxsize
    y2 = x2 + box(n).iconysize
    xoffset = x - x1
    yoffset = y - y1
    showmouse (0)
    draw.box.icon n, 0
    PUT (x1, y1), picture
    showmouse (1)
    doneonce = 0
    DO
        IF (oldmousex <> mousex OR oldmousey <> mousey) AND doneonce = 1 THEN
            x = mousex
            y = mousey
            oldmousex = x
            oldmousey = y
            x1 = x - xoffset
            y1 = y - yoffset
         
            '=========account for walls
            IF x1 > xscreensize - box(n).iconxsize THEN
                x1 = xscreensize - box(n).iconxsize
                x2 = xscreensize
                xoffset = x - x1
            END IF
            IF y1 > yscreensize - box(n).iconysize THEN
                y1 = yscreensize - box(n).iconysize
                y2 = yscreensize
                yoffset = y - y1
            END IF
            IF x1 < 0 THEN
                x1 = 0
                x2 = box(n).iconxsize
                xoffset = x - x1
            END IF
            IF y1 < 0 THEN
                y1 = 0
                y2 = box(n).iconysize
                yoffset = y - y1
            END IF
            IF y1 < ytextsize + 2 THEN
                y1 = ytextsize + 2
                y2 = y1 + box(n).iconysize
                yoffset = y - y1
            END IF
            '=============draw the icon if moving
            showmouse (0)
            PUT (oldx, oldy), picture2, PSET
            GET (x1, y1)-(x1 + box(n).iconxsize, y1 + box(n).iconysize), picture2
            box(n).iconx = x1
            box(n).icony = y1
            draw.box.icon n, 2
            showmouse (1)
        ELSEIF doneonce = 0 THEN
            doneonce = 1
            showmouse (0)
            FOR m = 1 TO numboxes
                IF n <> m AND box(m).onoff = 0 THEN
                    LOCATE 3, 1: PRINT boxes.icons.touching(n, m)
                    IF boxes.icons.touching(n, m) THEN draw.box.icon m, 1
                END IF
            NEXT m
            draw.box.icon n, 0
            GET (x1, y1)-(x1 + box(n).iconxsize, y1 + box(n).iconysize), picture2
            showmouse (1)
            box(n).iconx = x1
            box(n).icony = y1
        END IF
        oldx = x1
        oldy = y1
 
    LOOP UNTIL buttonpressed = 0
    showmouse (0)
    draw.box.icon n, 1
    showmouse (1)
END SUB

SUB draw.box.icon (n, c)
    SELECT CASE c
        CASE 0    '-----loads
            DEF SEG = VARSEG(picture(0))
            BLOAD boxicon$(n), VARPTR(picture(0))
            DEF SEG
     
        CASE 1 '----- loads and draws
            DEF SEG = VARSEG(picture(0))
            BLOAD boxicon$(n), VARPTR(picture(0))
            DEF SEG
            a = box(n).iconx
            b = box(n).icony
            c = a + box(n).iconxsize
            d = b + box(n).iconysize
            PUT (a, b), picture, PSET

        CASE 2 '------ draws
            a = box(n).iconx
            b = box(n).icony
            c = a + box(n).iconxsize
            d = b + box(n).iconysize
            PUT (a, b), picture, PSET
   
    END SELECT
END SUB

SUB draw.boxes
    '=============================== draw the boxes
    FOR n = 1 TO numboxes
        IF box(n).onoff = 0 THEN  '=========== draw the icon
            DEF SEG = VARSEG(picture(0))
            BLOAD boxicon$(n), VARPTR(picture(0))
            PUT (box(n).iconx, box(n).icony), picture, PSET
        ELSE             '==================== draw the box
            drawbox n, 1
        END IF
    NEXT n
END SUB

SUB drawbox (n, solid) STATIC
    IF doneonce = 0 THEN
        DIM button1(2633), button4(2633), button5(2633), button7(2633)
        DIM button2(2633), button3(2633), button6(2633)
        doneonce = 1
        DEF SEG = VARSEG(button1(0))
        BLOAD "close.pic", VARPTR(button1(0))
        DEF SEG = VARSEG(button2(0))
        BLOAD "open.pic", VARPTR(button2(0))
        DEF SEG = VARSEG(button3(0))
        BLOAD "resize.pic", VARPTR(button3(0))
        DEF SEG = VARSEG(button4(0))
        BLOAD "scrollu.pic", VARPTR(button4(0))
        DEF SEG = VARSEG(button5(0))
        BLOAD "scrolld.pic", VARPTR(button5(0))
        DEF SEG = VARSEG(button6(0))
        BLOAD "scrolll.pic", VARPTR(button6(0))
        DEF SEG = VARSEG(button7(0))
        BLOAD "scrollr.pic", VARPTR(button7(0))
    END IF
    showmouse (0)
    '--------------- draw the borders
    x1 = box(n).x
    y1 = box(n).y
    x2 = box(n).x + box(n).xsize
    y2 = box(n).y + box(n).ysize
    LINE (x1, y1)-(x2, y2), 0, BF
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + xboxbordersize, y1)-(x2 - xboxbordersize, y2), , B
    LINE (x1, y1 + yboxbordersize)-(x2, y2 - yboxbordersize), , B
    IF solid = 1 THEN
        ty = box(n).y + 2
        tx = INT((box(n).x + box(n).xsize / 2) - (xtextsize * LEN(boxname$(n)) / 2))
        drawtext tx, ty, boxname$(n), box(n).xsize - 2 * xboxbordersize
        '--------------- draw the icons
        PUT (x1 + xboxbordersize / 2 - button1(0) / 2, y1 + yboxbordersize / 2 - button1(1) / 2), button1, PSET
        PUT (x2 - xboxbordersize / 2 - button2(0) / 2, y1 + yboxbordersize / 2 - button2(1) / 2), button2, PSET
        PUT (x2 - xboxbordersize / 2 - button3(0) / 2, y2 - yboxbordersize / 2 - button3(1) / 2), button3, PSET
        PUT (x2 - xboxbordersize / 2 - button4(0) / 2, (y1 + y2) / 2 - yboxbordersize * 2), button4, PSET
        PUT (x2 - xboxbordersize / 2 - button5(0) / 2, (y1 + y2) / 2 - yboxbordersize), button5, PSET
        PUT (x2 - xboxbordersize / 2 - button6(0) / 2, (y1 + y2) / 2), button6, PSET
        PUT (x2 - xboxbordersize / 2 - button7(0) / 2, (y1 + y2) / 2 + yboxbordersize), button7, PSET
    END IF
    showmouse (1)
END SUB

SUB drawscreen
    '========================draw.menus
    showmouse (0)
    CLS
    n = 1
    menumax(0) = 1
    FOR a = 1 TO menus
        IF a = 1 THEN shift = 0
        n = n + LEN(menu$(a, 0)) + 4
        menumax(a) = n
        LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
        LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
    NEXT a
  
    LOCATE 1, 60 - INT(LEN(pagename$) / 2)
    PRINT pagename$

    '========= draw the flip buttons
    DEF SEG = VARSEG(button(0))
    BLOAD "flipl.pic", VARPTR(button(0))
    PUT (flipx, flipy), button, PSET
    flipxsize = button(0)
    flipysize = button(1)
    DEF SEG = VARSEG(button(0))
    BLOAD "flipr.pic", VARPTR(button(0))
    flipx2 = flipx + flipxsize + 2
    PUT (flipx2, flipy), button, PSET

   
    maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
    LINE (0, ytextsize)-(640, ytextsize)
    LINE (0, ytextsize - 2)-(maximum.menux, ytextsize - 2)
   
    showmouse (1)
END SUB

SUB drawtext (x, y, t$, maxlen)
    text$ = t$
    DIM letter(33)

    IF LEN(text$) * xtextsize > maxlen THEN
        text$ = LEFT$(text$, INT(maxlen / xtextsize))
    END IF
   
    FOR n = 1 TO LEN(text$)
        a$ = STR$(ASC(MID$(text$, n, 1)))
        a$ = RIGHT$(a$, LEN(a$) - 1)
        a$ = "fonts\char" + a$ + ".pic"
        DEF SEG = VARSEG(letter(0))
        BLOAD a$, VARPTR(letter(0))
        DEF SEG
        PUT (n * xtextsize + x, y), letter, PSET
    NEXT n
END SUB

FUNCTION exists (name$)
    SHELL ("dir/b/o " + name$ + " > junk")
    f = FREEFILE
    OPEN "junk" FOR INPUT AS #f
    ok = 0
    IF NOT EOF(f) THEN ok = 1
    CLOSE #f
    exists = ok
END FUNCTION

SUB expand.box (n)
    box(n).x = 0
    box(n).y = ytextsize + 1
    box(n).xsize = 639 - box(n).x
    box(n).ysize = 479 - box(n).y
    draw.boxes
END SUB

SUB flip.page (direction)
    np = current.page + direction
    IF np >= 1 AND np <= numpages THEN
        savepage
        current.page = np
        pagechanged = 1
    END IF
END SUB

SUB handle.buttonpress.on.box (current.box, mx, my)
    SELECT CASE button.pressed.on.box(current.box, mx, my)
        CASE 0  '---handle scrolling of box
            
        CASE 1  '---close box
            close.a.box (current.box)
        CASE 2  '---expand box
            expand.box (current.box)
        CASE 3  '---resize box
            resize.a.box (current.box)
        CASE 4  '---scroll up
        CASE 5  '---scroll down
        CASE 6  '---scroll left
        CASE 7  '---scroll right
        CASE 8  '---handle dragging of box
            drag.a.box (current.box)
    END SELECT
END SUB

SUB handle.option (option$)
    SELECT CASE option$
        CASE "Exit"
            close.a.menu
            n = FREEFILE
            OPEN "junk" FOR OUTPUT AS #n
            PRINT #n, "Yes.pic"
            PRINT #n, "no.pic"
            CLOSE #n
            IF choice("junk", 2, "Are you sure you want to exit?") = 1 THEN
                done = 1
                OPEN "cpg.~~" FOR OUTPUT AS #n
                PRINT #n, current.page
                CLOSE #n
                savepage
            END IF
        CASE "DOS Shell"
            close.a.menu
            showmouse (0)
            SCREEN 0
            SHELL
            SCREEN 12
            showmouse (1)
            PALETTE 0, 63 + 63 * 256 + 63 * 65536
            PALETTE 15, 0
            drawscreen
            draw.boxes
        CASE "Add a Page"
            close.a.menu
            add.a.page
        CASE "Turn to Page..."
            close.a.menu
            turn.to.page
        CASE "Remove a Page"
            close.a.menu
            remove.a.page
        CASE "Insert a Page"
            close.a.menu
            insert.a.page
        CASE "Retitle this Page"
            close.a.menu
            retitle.this.page
        CASE "Create a Box"
            close.a.menu
            create.a.box
        CASE "Remove a Box"
            close.a.menu
            remove.a.box
        CASE "Rename a Box"
            close.a.menu
            rename.a.box

    END SELECT
END SUB

SUB insert.a.page
    f = FREEFILE
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
        IF choice("junk", 2, "are you sure?") = 1 THEN
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            DO
                INPUT #f, a$
                IF a$ = pagename$ THEN
                    PRINT #g, pn$
                    PRINT #g, "{"
                    PRINT #g, "}"
                END IF
                PRINT #g, a$
            LOOP UNTIL EOF(f)
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            pagename$ = pn$
            numpages = numpages + 1
            pagechanged = 1
            drawscreen
        END IF
    END IF
END SUB

SUB load.boxes
    f = FREEFILE

    '================= Load data on all boxes on page
    OPEN "book.dat" FOR INPUT AS #f
    DO
        b$ = a$
        INPUT #f, a$
    LOOP UNTIL b$ = pagename$
    FOR n = 1 TO numboxes
        INPUT #f, boxname$(n)
        INPUT #f, junk
        INPUT #f, box(n).onoff
        INPUT #f, boxicon$(n)
        DEF SEG = VARSEG(picture(0))
        BLOAD boxicon$(n), VARPTR(picture(0))
        box(n).iconxsize = picture(0)
        box(n).iconysize = picture(1)
        INPUT #f, box(n).iconx
        INPUT #f, box(n).icony
        INPUT #f, box(n).x
        INPUT #f, box(n).y
        INPUT #f, box(n).xsize
        INPUT #f, box(n).ysize
        INPUT #f, box(n).scrollx
        INPUT #f, box(n).scrolly
        DO
            INPUT #f, a$
        LOOP UNTIL a$ = "]"
    NEXT n
    CLOSE #f

END SUB

SUB load.menus (filenum)
    FOR n = 1 TO menus
        INPUT #filenum, menu$(n, 0)
        INPUT #filenum, menulength(n)
        maximum.menux = maximum.menux + LEN(menu$(n, 0))
        FOR a = 1 TO menulength(n)
            INPUT #filenum, menu$(n, a)
        NEXT a
    NEXT n
    maximum.menux = maximum.menux * xtextsize
END SUB

SUB load.page
    f = FREEFILE
    IF exists("book.dat") THEN
        '============== find the current.page
        OPEN "book.dat" FOR INPUT AS #f
        fini = 0: pagesfound = 0
        WHILE NOT (EOF(f) OR fini = 1)
            b$ = a$
            INPUT #f, a$
            IF a$ = "{" THEN pagesfound = pagesfound + 1
            IF pagesfound = current.page THEN
                '================== find data on current page
                fini = 1
                pagename$ = b$
                '-------- check for boxes
                numboxes = 0
                DO
                    b$ = a$
                    INPUT #f, a$
                    IF a$ = "[" THEN numboxes = numboxes + 1
                LOOP UNTIL a$ = "}"
            END IF
        WEND
        CLOSE #f
    ELSE
        OPEN "book.dat" FOR OUTPUT AS #f
        PRINT #f, "GuiJe"
        PRINT #f, "{"
        PRINT #f, "}"
        CLOSE #f
        '====================== Create data for title page
        pagename$ = "GuiJe"

    END IF
END SUB

SUB message (filename$, iconname$)
    DIM background2(15000), background3(15000), background4(15000)
    '============= check the length & maxwidth of the file
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    maxwidth = 0
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        IF LEN(a$) > maxwidth THEN maxwidth = LEN(a$)
        numlines = numlines + 1
    WEND
    CLOSE #f
    '==================================set values, draw window
    '----- load the icon data
    DEF SEG = VARSEG(button(0))
    BLOAD iconname$, VARPTR(button(0))
    buttonxsize = button(0)
    buttonysize = button(1)
   
    '==================================set values, draw window

    '---- determine the necessary size of the window
    '--x
    textx = 40 - INT(maxwidth / 2)
    xminsize = (maxwidth + 3) * xtextsize
 
    '--y
    yminsize = numlines * ytextsize + buttonysize + 20

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse (0)

    '------- get background and print text
    mx = x1 + (x2 - x1) / 2
    my = y1 + (y2 - y1) / 2
    GET (x1, y1)-(mx, my), background
    GET (mx + 1, y1)-(x2, my), background2
    GET (x1, my + 1)-(mx, y2), background3
    GET (mx + 1, my + 1)-(x2, y2), background4
    LINE (x1, y1)-(x2, y2), 0, BF

    OPEN filename$ FOR INPUT AS #f
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        LOCATE texty + lnum, textx + (maxwidth - LEN(a$)) / 2
        lnum = lnum + 1
        PRINT a$
    WEND
    CLOSE #f
    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon position
    buttonx = 320 - button(0) / 2
    buttony = y2 - (button(1) + 5)

    '------- draw the icon
    PUT (buttonx, buttony), button
   
    showmouse (1)
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            IF x >= buttonx AND x <= buttonx + buttonxsize THEN
                IF y >= buttony AND y <= buttony + buttonysize THEN
                    gotone = 1
                END IF
            END IF
        END IF
        IF INKEY$ <> "" THEN gotone = 1
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse (0)
    PUT (x1, y1), background, PSET
    PUT (mx + 1, y1), background2, PSET
    PUT (x1, my + 1), background3, PSET
    PUT (mx + 1, my + 1), background4, PSET
    showmouse (1)
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

FUNCTION on.a.menu
    q = 0
    IF mousex > minmenx AND mousex < maxmenx THEN
        IF mousey > minmeny AND mousey < maxmeny THEN
             q = 1
        END IF
    END IF
    on.a.menu = q
END FUNCTION

FUNCTION on.closed.box (mx, my)
    FOR n = 1 TO numboxes
        IF box(n).onoff = 0 THEN
            x1 = box(n).iconx
            y1 = box(n).icony
            x2 = x1 + box(n).iconxsize
            y2 = y1 + box(n).iconysize
            IF x1 <= mx AND mx <= x2 AND y1 <= my AND my <= y2 THEN on.closed.box = n
        END IF
    NEXT n
END FUNCTION

FUNCTION on.open.box (x, y)
    FOR n = 1 TO numboxes
        IF box(n).onoff <> 0 THEN
            x1 = box(n).x
            y1 = box(n).y
            x2 = box(n).x + box(n).xsize
            y2 = box(n).y + box(n).ysize
            IF x >= x1 AND x <= x2 THEN
                IF y > y1 AND y < y2 THEN
                    x1 = x1 + xboxbordersize
                    y1 = y1 + yboxbordersize
                    x2 = x2 - xboxbordersize
                    y2 = y2 - yboxbordersize
                    IF y < y1 OR x < x1 OR y > y2 OR x > x2 THEN
                        on.open.box = n
                    END IF
                END IF
            END IF
        END IF
    NEXT n
END FUNCTION

SUB open.a.menu (menu.index)

    '--------- determine width
    menuwidth = 0
    FOR n = 1 TO menulength(menu.index)
        cwidth = LEN(menu$(menu.index, n))
        IF cwidth > menuwidth THEN menuwidth = cwidth
    NEXT n

    '--------- get screen
    minmenx = xtextsize * menumax(menu.index - 1) - xtextsize
    minmeny = ytextsize - ytextsize / 4
    maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + xtextsize
    maxmeny = menulength(menu.index) * ytextsize + minmeny + ytextsize / 2
    GET (minmenx, minmeny)-(maxmenx, maxmeny), background
    PUT (minmenx, minmeny), background
    old.menu.index = menu.index

    '--------- print text
    FOR n = 1 TO menulength(menu.index)
        LOCATE 1 + n, menumax(menu.index - 1) + 1
        PRINT menu$(menu.index, n)
    NEXT n

    '--------- separate text with dotted line
    FOR n = 2 TO menulength(menu.index)
        LINE (minmenx, n * ytextsize)-(maxmenx, n * ytextsize), 8, , 21845
    NEXT n

    '--------- draw edge of menu
    LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
    LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
    LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1), 7
    LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1), 7
    LINE (minmenx + 1, maxmeny - 1)-(maxmenx - 1, maxmeny - 1), 8
    LINE (maxmenx - 1, maxmeny - 1)-(maxmenx - 1, minmeny + 1), 8
    PSET (minmenx, minmeny), 0
    PSET (minmenx, maxmeny), 0
    PSET (maxmenx, minmeny), 0
    PSET (maxmenx, maxmeny), 0
    PSET (minmenx + 1, minmeny + 1)
    PSET (minmenx + 1, maxmeny - 1)
    PSET (maxmenx - 1, minmeny + 1)
    PSET (maxmenx - 1, maxmeny - 1)

END SUB

SUB open.box (n)
    box(n).onoff = 1
    showmouse (0)
    '=================== erase the icon
    DEF SEG = VARSEG(picture(0))
    BLOAD boxicon$(n), VARPTR(picture(0))
    PUT (box(n).iconx, box(n).icony), picture, PSET
    PUT (box(n).iconx, box(n).icony), picture, XOR
    '==================== draw the box
    drawbox n, 1
    showmouse (1)
END SUB

FUNCTION read.menu$
    y = mousey
    selection = 0
    FOR n = 1 TO menulength(old.menu.index)
        IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
            selection = n
        END IF
    NEXT n
    read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB remove.a.box
    f = FREEFILE
    OPEN "junk" FOR OUTPUT AS #f
    FOR n = 1 TO numboxes
        PRINT #f, boxname$(n)
    NEXT n
    CLOSE #f
  
    remove$ = choose$("junk")
    
    IF remove$ <> "" THEN
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "okay.pic"
        PRINT #f, "cancel.pic"
        CLOSE #f
        IF choice("junk", 2, "All information on this box will be erased.") = 1 THEN
            OPEN "book.dat" FOR INPUT AS #f
            g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
            WHILE NOT EOF(f)
                INPUT #f, a$
                IF a$ = remove$ THEN
                    DO
                        INPUT #f, a$
                    LOOP UNTIL a$ = "]"
                ELSE
                    PRINT #g, a$
                END IF
            WEND
            CLOSE f, g
            KILL "book.dat"
            SHELL "rename junk book.dat"
            numboxes = numboxes - 1
            pagechanged = 1
        END IF
    END IF
END SUB

SUB remove.a.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        b$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(b$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    pn$ = choose$("junk")

    '============= confirm removal of page
    OPEN "junk" FOR OUTPUT AS #f
    PRINT #f, "okay.pic"
    PRINT #f, "cancel.pic"
    CLOSE #f
    IF choice("junk", 2, "All data for this page will be removed.") = 1 THEN
        '============== remove the page
        OPEN "book.dat" FOR INPUT AS #f
        OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF LEFT$(a$, 12) <> pn$ THEN
                PRINT #g, a$
            ELSE
                DO
                    INPUT #f, a$
                LOOP UNTIL a$ = "}"
            END IF
        WEND
        CLOSE g, f
        KILL "book.dat"
        SHELL "rename junk book.dat"
        
        IF pn$ = pagename$ THEN
            current.page = 1
            load.page
            drawscreen
            pagechanged = 1
            numpages = numpages - 1
        END IF
    END IF
END SUB

SUB rename.a.box
    f = FREEFILE
    OPEN "junk" FOR OUTPUT AS #f
    FOR n = 1 TO numboxes
        PRINT #f, LEFT$(boxname$(n), 12)
    NEXT n
    CLOSE #f
    rename$ = choose$("junk")
   
    IF rename$ <> "" THEN
      
        DO
            continue = 1
            bn$ = taketext$("What title do you wish to give this box?")
            FOR n = 1 TO LEN(bn$)
                SELECT CASE MID$(bn$, n, 1)
                    CASE "[", "{", "(", ")", "}", "]"
                        continue = 0
                END SELECT
            NEXT n
            IF continue = 0 THEN
                SHELL "echo okay.pic > junk"
                v = choice("junk", 1, "The box title must not include braces or brackets.")
            END IF
        LOOP UNTIL continue = 1
      
        OPEN "junk" FOR OUTPUT AS #f
        PRINT #f, "yes.pic"
        PRINT #f, "no.pic"
        CLOSE #f
      
        IF choice("junk", 2, "Are you sure?") = 1 THEN
            IF bn$ <> "" THEN
                FOR n = 1 TO numboxes
                    IF LEFT$(boxname$(n), 12) = rename$ THEN boxname$(n) = bn$
                NEXT n
                OPEN "book.dat" FOR INPUT AS #f
                g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
                WHILE NOT EOF(f)
                    INPUT #f, a$
                    IF LEFT$(a$, 12) = rename$ THEN a$ = bn$
                    PRINT #g, a$
                WEND
                CLOSE f, g
                KILL "book.dat"
                SHELL "rename junk book.dat"
            END IF

        END IF
    END IF

END SUB

SUB resize.a.box (boxnum)
   
    x1 = box(boxnum).x
    y1 = box(boxnum).y
    x2 = box(boxnum).x + box(boxnum).xsize
    y2 = box(boxnum).y + box(boxnum).ysize
    LINE (x1, y1)-(x2, y2), 0, BF

    FOR n = 1 TO numboxes
        IF n <> boxnum THEN
            IF box(n).onoff = 0 THEN  '=========== draw the icon
                DEF SEG = VARSEG(picture(0))
                BLOAD boxicon$(n), VARPTR(picture(0))
                PUT (box(n).iconx, box(n).icony), picture, PSET
            END IF
        END IF
    NEXT n
    x1 = box(boxnum).x
    y1 = box(boxnum).y
    x2 = x1 + box(boxnum).xsize
    y2 = y1 + box(boxnum).ysize
    showmouse (0)
    LINE (x1, y1)-(x2, y2), 0, BF
    showmouse (1)
   
    mx = mousex
    my = mousey
    WHILE buttonpressed
        oldx = mx
        oldy = my
        mx = mousex
        my = mousey
        IF mx < x1 + xminboxsize THEN mx = x1 + xminboxsize
        IF my < y1 + yminboxsize THEN my = y1 + yminboxsize
        IF mx <> oldx OR my <> oldy OR doneonce = 0 THEN
            doneonce = 1
            showmouse (0)
            LINE (x1, y1)-(x2, y2), 0, BF
            showmouse (1)

            x1 = box(boxnum).x
            y1 = box(boxnum).y
            x2 = box(boxnum).x + box(boxnum).xsize
            y2 = box(boxnum).y + box(boxnum).ysize
          
            box(boxnum).xsize = mx - box(boxnum).x
            box(boxnum).ysize = my - box(boxnum).y
            drawbox boxnum, 0
        END IF
    WEND
    draw.boxes
END SUB

SUB retitle.this.page
    DO
        continue = 1
        pn$ = taketext$("What title do you wish to give this page?")
        FOR n = 1 TO LEN(pn$)
            SELECT CASE MID$(pn$, n, 1)
                CASE "[", "{", "(", ")", "}", "]"
                    continue = 0
            END SELECT
        NEXT n
        IF continue = 0 THEN
            SHELL "echo okay.pic > junk"
            v = choice("junk", 1, "The page title must not include braces or brackets.")
        END IF
    LOOP UNTIL continue = 1

    IF pn$ <> "" THEN
        f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
        g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
        WHILE NOT EOF(f)
            INPUT #f, a$
            IF a$ = pagename$ THEN
                PRINT #g, pn$
            ELSE
                PRINT #g, a$
            END IF
        WEND
        pagename$ = pn$
        CLOSE f, g
        KILL "book.dat"
        SHELL "rename junk book.dat"
        drawscreen
        draw.boxes
    END IF
END SUB

SUB savepage
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        INPUT #f, a$
        PRINT #g, a$
        IF a$ = pagename$ THEN
            DO
                INPUT #f, a$
            LOOP UNTIL a$ = "}"
            PRINT #g, "{"
            FOR n = 1 TO numboxes
                PRINT #g, boxname$(n)
                PRINT #g, "["
                PRINT #g, box(n).onoff
                PRINT #g, boxicon$(n)
                PRINT #g, box(n).iconx
                PRINT #g, box(n).icony
                PRINT #g, box(n).x
                PRINT #g, box(n).y
                PRINT #g, box(n).xsize
                PRINT #g, box(n).ysize
                PRINT #g, box(n).scrollx
                PRINT #g, box(n).scrolly
                PRINT #g, "]"
            NEXT n
            PRINT #g, "}"
        END IF
    WEND
    CLOSE f, g
    KILL "book.dat"
    SHELL "rename junk book.dat"
END SUB

SUB showmouse (mouseon)
    IF mouseon = 0 THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
END SUB

FUNCTION taketext$ (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse (0)
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    b = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = b + 2 * ytextsize
    LINE (a, b)-(c, d), , B
    LINE (a + 2, b + 2)-(c - 2, d - 2), , B
    LINE (a + 1, b + 1)-(a + 1, d - 1)
    LINE (a + 1, b + 1)-(c - 1, b + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse (1)
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 31
                IF n < 127 THEN
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = b$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        showmouse (0)
        LINE (a, b)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
         
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, offset + 1, maxlength)
            END IF
            PRINT display.text$
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        b = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, b)-(a, d)
        ELSE
            LINE (a, b)-(c, d), , B
        END IF
        showmouse (1)
    LOOP UNTIL ready OR cancel
    IF ready THEN taketext$ = text$
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue! (text$)
    '==================================set values, draw window
    DO: LOOP UNTIL INKEY$ = ""
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse (0)
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    b = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = b + 2 * ytextsize
    LINE (a, b)-(c, d), , B
    LINE (a + 2, b + 2)-(c - 2, d - 2), , B
    LINE (a + 1, b + 1)-(a + 1, d - 1)
    LINE (a + 1, b + 1)-(c - 1, b + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse (1)
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE ELSE
                IF ((n = 45) OR (n = 46) OR ((n < 58) AND (n > 47))) AND LEN(text$) < maxlength THEN '--(text)
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            b$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = b$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        LINE (a, b)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
            showmouse (0)
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, shift, maxlength)
            END IF
            PRINT display.text$

            'IF LEN(text$) <= maxlength THEN
            '    PRINT text$;
            'ELSE
            '    PRINT LEFT$(text$, maxlength);
            'END IF
            showmouse (1)
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        b = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, b)-(a, d)
        ELSE
            LINE (a, b)-(c, d), , B
        END IF
    LOOP UNTIL ready OR cancel
    IF ready THEN takevalue! = VAL(text$)
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

SUB turn.to.page
    '=================== compile a list of pages
    f = FREEFILE: OPEN "book.dat" FOR INPUT AS #f
    g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
    WHILE NOT EOF(f)
        b$ = a$
        INPUT #f, a$
        IF a$ = "{" THEN PRINT #g, LEFT$(b$, 12)
    WEND
    CLOSE #f, #g
  
    '============= get the page name
    a$ = choose$("junk")
   
    IF a$ <> "" THEN
        savepage
        pagename$ = a$
        '============= get the page number
        OPEN "junk" FOR INPUT AS #f
        current.page = 0
        DO
            INPUT #f, a$
            current.page = current.page + 1
        LOOP UNTIL a$ = pagename$
        CLOSE #f
        drawscreen
        pagechanged = 1
    END IF
END SUB

