DEFINT A-Z

'=============== declarations of subs
DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE SUB drawscreen ()
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION takevalue! (text$)
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE SUB showmouse ()
DECLARE SUB handle.option (option$)
DECLARE SUB close.a.menu ()
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB load.menus (filenum%)
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()

'=================================constants
CONST xtextsize = 8, ytextsize = 16

'======================= variables / types
TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE

DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(18000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED rusure(5000), menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED picture(2633), numpics, button(2633)
'------------load menus
OPEN "gui.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 6), menumax(menus), menulength(menus)
load.menus (1)
CLOSE #1
'=================================interrupts
'ON ERROR GOTO errhandle


'=========================Misc.
'------------set up graphics
SCREEN 12: CLS

PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0
'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
showmouse
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)
'------------draw the screen
drawscreen
'===============================main program==================================
DO
    '======================== left button pressed
    bp = buttonpressed
    mx = mousex
    my = mousey
    IF bp THEN
        IF my <= 15 THEN
            IF x <= maximum.menux THEN
                '------- left button on the upper menus
                IF menu.open <> 0 THEN
                    close.a.menu
                END IF
                IF menu.open <> current.menu THEN
                    menu.open = current.menu
                    showmouse
                    open.a.menu (current.menu)
                    showmouse
                END IF
                DO: LOOP UNTIL buttonpressed = 0
            END IF
        ELSEIF on.a.menu AND menu.open <> 0 THEN
            handle.option (read.menu$)'----read.menu$ is a function
        ELSE
            '------- button pressed off the menus
            IF menu.open <> 0 THEN
                close.a.menu
                DO: LOOP UNTIL buttonpressed = 0
            ELSE ' (all menus are closed)
            END IF
        END IF
    END IF
LOOP UNTIL done
CLOSE
END
'===============================subroutines===================================
errhandle:
   
    RESUME NEXT

FUNCTION buttonpressed
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

FUNCTION choice (filename$, icons, text$)
    '==================================set values, draw window
    DIM file$(icons), buttonxsize(icons), buttonysize(icons)
    DIM buttonx(icons), buttony(icons)
    '----- load the icon data
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    n = 0
    DEF SEG = VARSEG(button(0))
    FOR n = 1 TO icons
        INPUT #f, file$(n)
        BLOAD file$(n), VARPTR(button(0))
        buttonxsize(n) = button(0)
        buttonysize(n) = button(1)
    NEXT n
    CLOSE #f

    '---- determine the necessary size of the window
    '--x
    tlen = LEN(text$)
    textx = 40 - INT(tlen / 2)
    FOR n = 1 TO icons
        xminsize = xminsize + buttonxsize(n) + 10
    NEXT n
    IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize
  
    '--y
    FOR n = 1 TO icons
        IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
    NEXT n
    yminsize = yminsize + 40

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE texty, textx: PRINT text$;

    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon positions

    '-- x
    a = xminsize
    FOR n = 1 TO icons
        a = a - buttonxsize(n)
    NEXT n
    a = a / (icons + 1)
    icx = 320 - (xminsize / 2)
    FOR n = 1 TO icons
        icx = icx + a
        buttonx(n) = icx
        icx = icx + buttonxsize(n)
    NEXT n

    '-- y
    a = y2 - (y1 + 2 * ytextsize)
    a = y2 - a / 2
    FOR n = 1 TO icons
        buttony(n) = a - buttonysize(n) / 2
    NEXT n
                          
    '----- load and draw the icons
    FOR n = 1 TO icons
        DEF SEG = VARSEG(button(0))
        BLOAD file$(n), VARPTR(button(0))
        PUT (buttonx(n), buttony(n)), button
    NEXT n
    DEF SEG

    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            FOR n = 1 TO icons
                IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
                    IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
                        choice = n
                        gotone = n
                    END IF
                END IF
            NEXT n
        END IF
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    showmouse
END FUNCTION

SUB close.a.menu '(menu.index)
    showmouse
    'PUT (xtextsize * menumax(old.menu.index - 1), ytextsize), background, PSET
    PUT (minmenx, minmeny), background, PSET
    showmouse
    menu.open = 0
END SUB

FUNCTION current.menu
    FOR n = 1 TO menus
        IF mousex < menumax(n) * xtextsize THEN EXIT FOR
    NEXT n
    IF n > menus THEN n = menus
    current.menu = n
END FUNCTION

SUB drawscreen
    '========================draw.menus
    showmouse
    CLS
    n = 1
    menumax(0) = 1
    FOR a = 1 TO menus
        IF a = 1 THEN shift = 0
        n = n + LEN(menu$(a, 0)) + 4
        menumax(a) = n
        LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
        LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
    NEXT a
   
   
    maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
    LINE (0, ytextsize)-(640, ytextsize)
    LINE (0, ytextsize - 2)-(maximum.menux, ytextsize - 2)
   
    showmouse
END SUB

SUB handle.option (option$)
    SELECT CASE option$
        CASE "Exit"
            close.a.menu
            n = FREEFILE
            OPEN "junk" FOR OUTPUT AS #n
            PRINT #n, "Yes.pic"
            PRINT #n, "no.pic"
            CLOSE #n
            IF choice("junk", 2, "Are you sure you want to exit?") = 1 THEN
                done = 1
            END IF
    END SELECT
END SUB

SUB load.menus (filenum)
    FOR n = 1 TO menus
        INPUT #filenum, menu$(n, 0)
        INPUT #filenum, menulength(n)
        maximum.menux = maximum.menux + LEN(menu$(n, 0))
        FOR a = 1 TO menulength(n)
            INPUT #filenum, menu$(n, a)
        NEXT a
    NEXT n
    maximum.menux = maximum.menux * xtextsize
END SUB

SUB message (filename$, iconname$)
    DIM background2(18000), background3(18000), background4(18000)
    '============= check the length & maxwidth of the file
    f = FREEFILE
    OPEN filename$ FOR INPUT AS #f
    maxwidth = 0
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        IF LEN(a$) > maxwidth THEN maxwidth = LEN(a$)
        numlines = numlines + 1
    WEND
    CLOSE #f
    '==================================set values, draw window
    '----- load the icon data
    DEF SEG = VARSEG(button(0))
    BLOAD iconname$, VARPTR(button(0))
    buttonxsize = button(0)
    buttonysize = button(1)
   
    '==================================set values, draw window

    '---- determine the necessary size of the window
    '--x
    textx = 40 - INT(maxwidth / 2)
    xminsize = (maxwidth + 3) * xtextsize
 
    '--y
    yminsize = numlines * ytextsize + buttonysize + 20

    x1 = 320 - (xminsize / 2)
    y1 = 240 - (yminsize / 2)
    x2 = 320 + (xminsize / 2)
    y2 = 240 + (yminsize / 2)
    texty = INT(y1 / ytextsize) + 2

    showmouse

    '------- get background and print text
    mx = x1 + (x2 - x1) / 2
    my = y1 + (y2 - y1) / 2
    GET (x1, y1)-(mx, my), background
    GET (mx + 1, y1)-(x2, my), background2
    GET (x1, my + 1)-(mx, y2), background3
    GET (mx + 1, my + 1)-(x2, y2), background4
    LINE (x1, y1)-(x2, y2), 0, BF

    OPEN filename$ FOR INPUT AS #f
    WHILE NOT EOF(f)
        LINE INPUT #f, a$
        LOCATE texty + lnum, textx + (maxwidth - LEN(a$)) / 2
        lnum = lnum + 1
        PRINT a$
    WEND
    CLOSE #f
    '------- draw box borders of the window
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

    '------- determine the icon position
    buttonx = 320 - button(0) / 2
    buttony = y2 - (button(1) + 5)

    '------- draw the icon
    PUT (buttonx, buttony), button
   
    showmouse
    '========== handle i/o
    DO
        x = mousex
        y = mousey
        IF buttonpressed = 1 THEN
            IF x >= buttonx AND x <= buttonx + buttonxsize THEN
                IF y >= buttony AND y <= buttony + buttonysize THEN
                    gotone = 1
                END IF
            END IF
        END IF
        IF INKEY$ <> "" THEN gotone = 1
    LOOP UNTIL gotone <> 0
    '======= redraw screen
    showmouse
    PUT (x1, y1), background, PSET
    PUT (mx + 1, y1), background2, PSET
    PUT (x1, my + 1), background3, PSET
    PUT (mx + 1, my + 1), background4, PSET
    showmouse
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

FUNCTION on.a.menu
    q = 0
    IF mousex > minmenx AND mousex < maxmenx THEN
        IF mousey > minmeny AND mousey < maxmeny THEN
             q = 1
        END IF
    END IF
    on.a.menu = q
END FUNCTION

SUB open.a.menu (menu.index)

    '--------- determine width
    menuwidth = 0
    FOR n = 1 TO menulength(menu.index)
        cwidth = LEN(menu$(menu.index, n))
        IF cwidth > menuwidth THEN menuwidth = cwidth
    NEXT n

    '--------- get screen
    minmenx = xtextsize * menumax(menu.index - 1) - xtextsize
    minmeny = ytextsize - ytextsize / 4
    maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + xtextsize
    maxmeny = menulength(menu.index) * ytextsize + minmeny + ytextsize / 2
    GET (minmenx, minmeny)-(maxmenx, maxmeny), background
    PUT (minmenx, minmeny), background
    old.menu.index = menu.index

    '--------- print text
    FOR n = 1 TO menulength(menu.index)
        LOCATE 1 + n, menumax(menu.index - 1) + 1
        PRINT menu$(menu.index, n)
    NEXT n

    '--------- separate text with dotted line
    FOR n = 2 TO menulength(menu.index)
        LINE (minmenx, n * ytextsize)-(maxmenx, n * ytextsize), 8, , 21845
    NEXT n

    '--------- draw edge of menu
    LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
    LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
    LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1), 7
    LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1), 7
    LINE (minmenx + 1, maxmeny - 1)-(maxmenx - 1, maxmeny - 1), 8
    LINE (maxmenx - 1, maxmeny - 1)-(maxmenx - 1, minmeny + 1), 8
    PSET (minmenx, minmeny), 0
    PSET (minmenx, maxmeny), 0
    PSET (maxmenx, minmeny), 0
    PSET (maxmenx, maxmeny), 0
    PSET (minmenx + 1, minmeny + 1)
    PSET (minmenx + 1, maxmeny - 1)
    PSET (maxmenx - 1, minmeny + 1)
    PSET (maxmenx - 1, maxmeny - 1)

END SUB

FUNCTION read.menu$
    y = mousey
    selection = 0
    FOR n = 1 TO menulength(old.menu.index)
        IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
            selection = n
        END IF
    NEXT n
    read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB showmouse STATIC
    IF mouseon THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
    mouseon = 1 - mouseon
END SUB

FUNCTION taketext$ (text$)
    '==================================set values, draw window
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE IS > 31
                IF n < 127 THEN
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        showmouse
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
         
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, offset + 1, maxlength)
            END IF
            PRINT display.text$
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
        showmouse
    LOOP UNTIL ready OR cancel
    IF ready THEN taketext$ = text$
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue! (text$)
    '==================================set values, draw window
    textx = 40 - INT(LEN(text$) / 2)
    x1 = (textx - 3) * xtextsize
    y1 = 13 * ytextsize
    x2 = x1 + xtextsize * (LEN(text$) + 3)
    y2 = y1 + ytextsize * 6
    showmouse
    GET (x1, y1)-(x2, y2), background
    PUT (x1, y1), background
    LOCATE 15, textx: PRINT text$;
    LINE (x1, y1)-(x2, y2), , B
    LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
    LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
    LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
    a = (textx - 1.5) * xtextsize - 2
    B = 15.5 * ytextsize
    c = a + (LEN(text$) + 1) * xtextsize
    d = B + 2 * ytextsize
    LINE (a, B)-(c, d), , B
    LINE (a + 2, B + 2)-(c - 2, d - 2), , B
    LINE (a + 1, B + 1)-(a + 1, d - 1)
    LINE (a + 1, B + 1)-(c - 1, B + 1)
    '=================================== Handle I/O
    maxlength = LEN(text$) - 1
    text$ = ""
    LOCATE 17, textx
    showmouse
    DO
        DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
        IF doneonce = 0 THEN
            doneonce = 1
            write.the.text = 1
        END IF
        IF a$ <> "" THEN
            n = ASC(LEFT$(a$, 1))
        ELSE
            n = 1000
        END IF
        SELECT CASE n
            CASE 0
                m$ = RIGHT$(a$, 1)
                SELECT CASE m$
                    CASE "K"'--left
                        IF LEN(text$) + offset > 0 THEN offset = offset - 1
                    CASE "M"'--right
                        IF offset < 0 THEN offset = offset + 1
                    CASE CHR$(83)'--(Delete)
                        IF offset < 0 THEN
                            n = LEN(text$) + offset
                            text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
                            offset = offset + 1
                            write.the.text = 1
                            erase.last.character = 1
                        END IF
                    CASE CHR$(82)'--(insert)
                        insert = 1 - insert
                END SELECT
            CASE 8 '--(bspace)
                 IF LEN(text$) > ABS(offset) THEN
                    IF offset = 0 THEN
                        text$ = LEFT$(text$, LEN(text$) - 1)
                    ELSE
                        n = LEN(text$) + offset
                        text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
                    END IF
                    erase.last.character = 1
                    write.the.text = 1
                END IF
            CASE 27
                cancel = 1
            CASE 13
                ready = 1
            CASE ELSE
                IF ((n = 45) OR (n = 46) OR ((n < 58) AND (n > 47))) AND LEN(text$) < maxlength THEN '--(text)
                    IF offset = 0 THEN
                        text$ = text$ + a$
                        write.the.text = 1
                    ELSE
                        n = LEN(text$) + offset
                        IF insert THEN
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
                        ELSE
                            B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
                            offset = offset + 1
                        END IF
                        text$ = B$
                        write.the.text = 1
                    END IF
                END IF
        END SELECT
        LINE (a, B)-(c, d), 0, B
        IF LEN(text$) > maxlength THEN shift = shift + 1
        IF write.the.text OR erase.last.character THEN
            IF erase.last.character THEN
                erase.last.character = 0
                LOCATE 17, textx + LEN(text$)
                PRINT " ";
            END IF
            write.the.text = 0
            LOCATE 17, textx
            showmouse
            IF LEN(text$) <= maxlength THEN
                display.text$ = text$
            ELSE
                display.text$ = MID$(text$, shift, maxlength)
            END IF
            PRINT display.text$

            'IF LEN(text$) <= maxlength THEN
            '    PRINT text$;
            'ELSE
            '    PRINT LEFT$(text$, maxlength);
            'END IF
            showmouse
        END IF
        cursormode = insert
        a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
        B = ytextsize * 16
        c = xtextsize * (textx + LEN(text$) + offset) - 1
        d = ytextsize * 17
        IF cursormode = 1 THEN
            LINE (a, B)-(a, d)
        ELSE
            LINE (a, B)-(c, d), , B
        END IF
    LOOP UNTIL ready OR cancel
    IF ready THEN takevalue! = VAL(text$)
    PUT (x1, y1), background, PSET
'==============
END FUNCTION

